package com.chinacreator.video.controller;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.chinacreator.video.mapper.DictionaryDao;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.alibaba.fastjson.JSON;
import com.chinacreator.video.annotation.Log;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.dto.DataOutPipe;
import com.chinacreator.video.dto.OrderVipOutPipe;
import com.chinacreator.video.dto.QueryDataOutPipe;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.service.ChannelOrderService;
import com.chinacreator.video.service.ChannelOrderVipService;
import com.chinacreator.video.service.OrderService;
import com.chinacreator.video.util.URLUtil;

@RestController
public class OrderControl {

	protected static Logger logger = LoggerFactory.getLogger(OrderControl.class);

	@Autowired
	private OrderService orderService;

	@Autowired
	private ChannelOrderService channelOrderService;

	@Autowired
	private ChannelOrderVipService channelOrderVipService;
	@Autowired
	private DictionaryDao dictionaryDao;
	@Log
	@RequestMapping("/order")
	public DataOutPipe<?> order(OrderInfo orderInfo) throws Exception {
		orderInfo.setTimes(System.currentTimeMillis() + "");
		DataOutPipe<?> pie = new DataOutPipe<>();
		orderInfo.setInvokeface("order");
		int ordertype = orderInfo.getOrdertype();
		if (ordertype == 1 || ordertype == 2) {
			efftOrder(orderInfo);
			inserSmstMq(orderInfo, "0");
			inserOrderMq(orderInfo, "0");
		} else {
			preorder(orderInfo);
			if (orderInfo.getSpid().equals("84") && orderInfo.getOrdertype() == 1) {
				inserSmstMq(orderInfo, "0");
				inserOrderMq(orderInfo, "0");
			}
		}
		return pie;
	}

	@Log
	@RequestMapping("/channelOrderVip")
	public OrderVipOutPipe channelOrder(OrderInfo orderInfo) throws Exception {
		orderInfo.setTimes(System.currentTimeMillis() + "");
		orderInfo.setOrdertype(2);
		OrderVipOutPipe pie = new OrderVipOutPipe();
		orderInfo.setInvokeface("channelOrderVip");
		channelOrderVipService.orderValidate(orderInfo);
		if (orderInfo.getType() == 0) {
			try {
				channelOrderVipService.channelOrder(orderInfo);
				if (orderInfo.getSpid().equals("101")) {
					inserSmstMq(orderInfo, "0");
					inserOrderMq(orderInfo, "0");
				}
				pie.setOrderstatus("0");
				channelOrderVipService.channelVip(orderInfo);
				pie.setVipstatus("0");
			} catch (Exception e) {
				if (e instanceof BussinessException) {
					pie.setResultcode(((BussinessException) e).getCode());
					pie.setErrorinfo(((BussinessException) e).getMessage());
				} else {
					pie.setResultcode("8000");
					pie.setErrorinfo("系统忙,请稍后再试！");
				}
			}
		} else {
			channelOrderVipService.channelCancel(orderInfo);
			if (orderInfo.getSpid().equals("101")) {
				inserSmstMq(orderInfo, "1");
				inserOrderMq(orderInfo, "1");
			}
		}
		return pie;
	}

	@Log
	@RequestMapping("/channelOrder")
	public DataOutPipe<?> channelOrderVip(OrderInfo orderInfo) throws Exception {
		orderInfo.setTimes(System.currentTimeMillis() + "");
		DataOutPipe<?> pie = new DataOutPipe<>();
		orderInfo.setInvokeface("channelOrder");
		channelOrderService.orderValidate(orderInfo);
		if (orderInfo.getType() == 0) {
			if (orderInfo.getOrdertype() == 0) {
				orderInfo.setOrdertype(1);
			}

			this.channelOrderService.channelOrder(orderInfo);
			if (orderInfo.getSpid().equals("101")) {
				this.inserSmstMq(orderInfo, "0");
				this.inserOrderMq(orderInfo, "0");
			}
		} else {
			if (orderInfo.getCanceltype() == 0) {
				orderInfo.setCanceltype(1);
			}

			this.channelOrderService.channelCancel(orderInfo);
			if (orderInfo.getSpid().equals("101")) {
				this.inserSmstMq(orderInfo, "1");
				this.inserOrderMq(orderInfo, "1");
			}
		}

		return pie;
	}

	public void efftOrder(OrderInfo orderInfo) throws Exception {
		orderService.orderCheck(orderInfo);
		orderService.order(orderInfo);
	}

	@Log
	@RequestMapping("/cancel")
	public DataOutPipe<?> cancel(OrderInfo orderInfo) throws Exception {
		orderInfo.setTimes(System.currentTimeMillis() + "");
		DataOutPipe<?> pie = new DataOutPipe<>();
		orderInfo.setInvokeface("cancel");
		int canceltype = orderInfo.getCanceltype();
		if (canceltype == 1 || canceltype == 2) {
			try {
				efftCancel(orderInfo);
			} catch (Exception e) {
				if (orderInfo.getSpid().equals("6")) {
					inserSmstMq(orderInfo, "2");
				}
				throw e;
			}
				inserSmstMq(orderInfo, "1");
				inserOrderMq(orderInfo, "1");
		} else {
			precancel(orderInfo);
			if (orderInfo.getSpid().equals("84") && orderInfo.getCanceltype() == 5) {
				inserSmstMq(orderInfo, "1");
				inserOrderMq(orderInfo, "1");
			}
		}
		return pie;
	}

	public void efftCancel(OrderInfo orderInfo) throws Exception {
		if (orderInfo.getCpid().equals("twowei")) {
			if (orderInfo.getSpid().equals("10013")) {
				this.orderService.orderCheck(orderInfo);
				orderInfo.setSpid("101");
			} else {
				this.orderService.orderCheck(orderInfo);
				orderInfo.setSpid("84");
			}

			this.orderService.cancel(orderInfo);
		} else {
			this.orderService.orderCheck(orderInfo);
			this.orderService.cancel(orderInfo);
		}

	}

	public void preorder(OrderInfo orderInfo) throws Exception {
		orderService.orderCheck(orderInfo);
		orderService.preOrder(orderInfo);
	}

	public void precancel(OrderInfo orderInfo) throws BussinessException {
		orderService.orderCheck(orderInfo);
		orderService.preCancel(orderInfo);
	}

	@Log
	@RequestMapping("/queryOrder")
	public DataOutPipe<?> querOrder(OrderInfo orderInfo) throws Exception {
		DataOutPipe<List<QueryDataOutPipe>> pie = new DataOutPipe<>();
		orderService.orderCheck(orderInfo);
		List<QueryDataOutPipe> list = orderService.queryOrder(orderInfo);
		pie.setData(list);
		return pie;
	}

	@Log
	@RequestMapping("/queryChannelOrder")
	public DataOutPipe<?> querChannelOrder(OrderInfo orderInfo) throws Exception {
		DataOutPipe<List<QueryDataOutPipe>> pie = new DataOutPipe<>();
		channelOrderVipService.channelQueryValidate(orderInfo);
		List<QueryDataOutPipe> alllist = channelOrderVipService.queryOrder(orderInfo);
		List<QueryDataOutPipe> list = new ArrayList<>();
		if(alllist != null && alllist.size()>0) {
			for (QueryDataOutPipe queryDataOutPipe : alllist) {
				if(queryDataOutPipe.getSpid().equals(orderInfo.getSpid())) {
					list.add(queryDataOutPipe);
				}
			}
		}
		pie.setData(list);
		return pie;
	}

	public void inserSmstMq(OrderInfo orderInfo, String type) {
		if(orderInfo.getCpid().equals("tencent") && orderInfo.getSpid().equals("101") || orderInfo.getCpid().equals("tencent") && orderInfo.getSpid().equals("84") || orderInfo.getCpid().equals("cctv") && orderInfo.getSpid().equals("10081")) {
			try {
				Map<String, String> map = new HashMap<String, String>();
				map.put("userid", orderInfo.getUserid());
				map.put("cpid", orderInfo.getCpid());
				map.put("spid", orderInfo.getSpid());
				map.put("result", "0");
				//map.put("channel", "");
				map.put("channel",orderInfo.getChannel());
				if(orderInfo.getChannel() != null && !"".equals(orderInfo.getChannel()) && orderInfo.getSubchannel() != null && !"".equals(orderInfo.getSubchannel())){
					map.put("style","0000");
					map.put("subchannel",orderInfo.getSubchannel());
					if(type.equals("0")){
						map.put("busiType", "tran_succ");
					} else if(type.equals("1")){
						map.put("busiType", "cancel_succ");
					}else{
						map.put("busiType", "cancel_fail");
					}
				}else{
					if(orderInfo.getCpid().equals("tencent")) {
						if (type.equals("0")) {
							map.put("style", "7");
							map.put("busiType", "tran_succ");
						} else if(type.equals("1")){
							map.put("style", "8");
							map.put("busiType", "cancel_succ");
						}else {
							map.put("style", "9");
							map.put("busiType", "cancel_fail");
						}
					}else if(orderInfo.getCpid().equals("cctv")) {
						if (type.equals("0")) {
							map.put("style", "10");
							map.put("busiType", "tran_succ");
						} else if(type.equals("1")){
							map.put("style", "11");
							map.put("busiType", "cancel_succ");
						}
					}
				}

				map.put("times", "");
				map.put("orderType", "");
				map.put("type", "cssms");
				String  mqReciveUrl = dictionaryDao.getValue("mqReciveUrl");
				URLUtil.post(mqReciveUrl, JSON.toJSONString(map));
				//URLUtil.post("http://10.199.99.177:86/mq-service/recive.do", JSON.toJSONString(map));
			} catch (Exception e) {
				logger.error(e.getMessage());
				e.printStackTrace();
			}
		}
	}

	public void inserOrderMq(OrderInfo orderInfo, String type) {
		if((orderInfo.getCpid().equals("tencent") && orderInfo.getSpid().equals("84")) || (orderInfo.getCpid().equals("cctv") && orderInfo.getSpid().equals("10081"))) {
			try {
				Map<String, String> map = new HashMap<String, String>();
				map.put("userid", orderInfo.getUserid());
				map.put("cpid", orderInfo.getCpid());
				map.put("spid", orderInfo.getSpid());
				if (type.equals("0")) {
					map.put("status", "0");
					map.put("ordertime", orderInfo.getOrdertime());
					map.put("channel", orderInfo.getOrderchannel());
				} else {
					map.put("status", "1");
					map.put("canceltime", orderInfo.getCanceltime());
					map.put("channel", orderInfo.getCancelchannel());
				}
				map.put("type", "vacorder");
				String  mqReciveUrl = dictionaryDao.getValue("mqReciveUrl");
				URLUtil.post(mqReciveUrl, JSON.toJSONString(map));
				//URLUtil.post("http://10.199.99.177:86/mq-service/recive.do", JSON.toJSONString(map));
			} catch (Exception e) {
				logger.error(e.getMessage());
				e.printStackTrace();
			}
		}
	}
}
