package com.chinacreator.video.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.chinacreator.video.bean.ActivityAiqy7Bean;
import com.chinacreator.video.bean.ActivityAiqy7OrderRelation;


public interface ActiveAiqy7Dao {
	
	String getSysTime();
	
	/**
	 * 查询当前的活动关系表
	 * 
	 * @param userid
	 * @return
	 */
	ActivityAiqy7Bean findByUserid(@Param("userid")String userid);
	
	/**
	 * 查询当前订购关系表
	 * 
	 * @param userid
	 * @return
	 */
	ActivityAiqy7OrderRelation findOrderRelationByUserid(@Param("userid")String userid);
	
	/**
	 * 从订购日志表中查询订购时间后，最早的退订日志
	 * 
	 * @return
	 */
	List<String> findCanceltimeFromLog(@Param("userid")String userid);
	
	
	
	int insert(@Param("userid")String userid,
			@Param("cpid")String cpid,
			@Param("spid")String spid,
			@Param("status")String status,
			@Param("activetype")String activetype,
			@Param("ordertime")String ordertime,
			@Param("canceltime")String canceltime);
	
	int insertVip(@Param("userid")String  userid,
			@Param("vipmonth")String vipmonth,
			@Param("status")String status,
			@Param("activetype")String activetype,
			@Param("vipid")String vipid,
			@Param("orderid")String orderid);
	
	int getVipUpdate(@Param("userid")String userid,@Param("status")String status,@Param("canceltime")String canceltime);
	
	int getNotVipUpdate(@Param("userid")String userid,@Param("status")String status,@Param("canceltime")String canceltime);
	
	
//	
//	
//	
//	
//	
//	int queryVipCountCurDay();
//	
//	int queryVipCountTotal();
//	
//	/**
//	 * 查询订购数，已经订购了的不能领取
//	 * @param userid
//	 * @return
//	 */
//	int queryOrderRelation16(@Param("userid")String userid);
//	
//	int queryOrderRelation15(@Param("userid")String userid);
//	
//	/**
//	 * 查询号段是不是联通号段
//	 * 
//	 * @param userid
//	 * @return
//	 */
//	int queryHeader(@Param("userid")String userid);
//	
//	/**
//	 * 查询携号转网
//	 * 
//	 * @param userid
//	 * @return
//	 */
//	int queryXHZW(@Param("userid")String userid);
//	
//	
//	/**
//	 * 是否有领到记录
//	 * 
//	 * @param userid
//	 * @return
//	 */
//	int getJoinRecord(@Param("userid")String userid);
//	
//	
//	/**
//	 * 领取会员记录
//	 * 
//	 * @param id
//	 * @param userid
//	 * @param cpid
//	 * @param spid
//	 * @param activetype
//	 * @param vipstatus
//	 */
//	int insert(@Param("userid")String  userid,
//			@Param("activetype")String activetype,
//			@Param("vipid")String vipid,
//			@Param("status")String status,
//			@Param("orderid")String orderid);
//
//	
//	/**
//	 * 查询记录状态
//	 * 
//	 * @param userid
//	 * @return
//	 */
//    String getRecordStatus(@Param("userid")String userid);
//	
//	
//	/**
//	 * 更新领取状态
//	 * 
//	 * @param userid
//	 * @param status
//	 * @return
//	 */
//	int updateJoinStatus(@Param("userid")String userid,@Param("status")String status,@Param("old")String old);
//	
//	/**
//	 * 更新领取状态
//	 * 
//	 * @param userid
//	 * @param status
//	 * @return
//	 */
//	int joinSucceed(@Param("userid")String userid,@Param("status")String status);
//	
//	
//	int deteleJoining(@Param("userid")String userid);
}
