package com.chinacreator.video.mapper;

import com.chinacreator.video.bean.ActivityMgtvShareBean;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface ActiveMgtvShareDao {

    void insertShare( @Param("userid") String userid,
                      @Param("shareuser") String shareuser,
                      @Param("activetime") String activetime,
                      @Param("cpid") String cpid,
                      @Param("spid") String spid,
                      @Param("activetype") String activetype);

    void insertRank( @Param("userid") String userid,
                      @Param("rank") String rank,
                      @Param("prize") String prize,
                      @Param("activetime") String activetime, @Param("count") String count);

    String getOrderRelation(@Param("userid") String userid,
                         @Param("cpid") String cpid,
                         @Param("spid") String spid);

    int orderLogCount(@Param("userid") String userid,
                      @Param("cpid") String cpid,
                      @Param("spid") String spid);

    int getShareOrderRelation(@Param("userid") String userid,
                              @Param("cpid") String cpid,
                              @Param("spid") String spid);

    int getJoinCount(@Param("cpid") String cpid,
                     @Param("spid") String spid,
                     @Param("activetime") String activetime);

    /**
     * 分享订购记录
     * @param userid
     * @param cpid
     * @param spid
     * @param activetype
     * @return
     */
    int getShareActive(@Param("userid") String userid,
                       @Param("cpid") String cpid,
                       @Param("spid") String spid,
                       @Param("activetype") String activetype);

    /**
     * 保存中奖信息
     * @param username
     * @param address
     * @param phone
     * @param id
     * @return
     */
    int savePrize(@Param("username") String username,
                  @Param("address") String address,
                  @Param("phone") String phone,
                  @Param("id") String id);

    /**
     * 是否中奖用户
     * @param userid
     * @return
     */
    int getPrizeCount(@Param("userid") String userid);

    /**
     * 获取今日获奖记录
     */
    int getTodayCount();
    /**
     * 填写信息资格查询
     * @param userid
     * @return
     */
    String getSavePrize(@Param("userid") String userid);


    /**
     * 中奖记录查询
     */
    List<ActivityMgtvShareBean> getPrize();

    /**
     * 实时分享排名
     */
    List<ActivityMgtvShareBean> getRankNow(@Param("activetime") String activetime);

    /**
     * 今日最终中奖名单
     */
    List<ActivityMgtvShareBean> getTodayRank(@Param("activetime") String activetime);
}
