package com.chinacreator.video.mapper;

import org.apache.ibatis.annotations.Param;
import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.Cacheable;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 查询公共配置
 * @author xu.zhou
 * @date 20190627
 */
@CacheConfig(cacheNames = "CommConfDao")
public interface CommConfDao {

	   @Cacheable
	   List<Map> getCpSpInfo();

	   /**
	    * 查询次数限制配置
	    * @return
	    */
	   @Cacheable
	   List<Map> getlimitQryConf();

	   /**
	    * 根据busitype和channel获取IP配置信息
	    * @param busitype
	    * @param channel
	    * @return
	    */
	   @Cacheable
	   List<Map> getIpLimitConf(@Param("busitype") String busitype, @Param("channel") String channel);

	   /**
	    * 根据手机号码查询所有订购数据
	    * @param userid
	    * @return
	    */
	   List<Map> getAllOrder(@Param("userid") String userid);
	   
	   @Cacheable
	   public List<HashMap> qryProvInvokeLimit(@Param("province")String province,  @Param("channel")String channel, @Param("invokeface")String invokeface, @Param("type")String type);

}
