package com.chinacreator.video.service;


import com.alibaba.fastjson.JSON;
import com.chinacreator.video.bean.ActivityLimitConfig;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.ActiveAiqy20Dao;
import com.chinacreator.video.redis.RedisService;
import com.chinacreator.video.util.IpAddrUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Random;

@Component
public class ActivityAiqy20Service {

    private static Logger ErrorLOGGER = LoggerFactory.getLogger("ERROR");

    @Autowired
    private RedisService redisService;

    @Autowired
    private ComonService comonService;

    @Autowired
    private MobService mobService;

    @Autowired
    private ActivityConfigService activityService;

    @Autowired
    private ActiveAiqy20Dao activeDao;

    /**
     * 取值
     * @param key
     * @return
     * @throws BussinessException
     */
    public long getRedis(String key) throws BussinessException {
        try {
            String count = redisService.get(key);
            System.out.println(key+":"+count);
            if(StringUtils.isEmpty(count)){
                return 0;
            }
            return Long.parseLong(count);

        } catch (Exception e) {

            ErrorLOGGER.error("", e);

        }
        return 0;
    }


    /**
     * 设值
     * @param key
     * @param value
     * @throws BussinessException
     */
    public void setRedis(String key,String value) throws BussinessException {
        try {
            redisService.add(key,value);
            System.out.println(key+":"+value);
        } catch (Exception e) {
            ErrorLOGGER.error("", e);
        }
    }

    /**
     *  加1
     * @param key
     * @return
     * @throws BussinessException
     */
    public long addRedis(String key) throws BussinessException {
        try {
            long count = redisService.incrAdd(key,60L*60L*24L*100L);
            System.out.println(key+":"+count);
            return count;
        } catch (Exception e) {
            ErrorLOGGER.error("", e);
        }
        return 0;
    }

    /**
     * 减1
     * @param key
     * @return
     * @throws BussinessException
     */
    public long backRedis(String key) throws BussinessException{
        try {
            long count = redisService.incrBack(key,60L*60L*24L*100L);
            System.out.println(key+":"+count);
            return count;
        } catch (Exception e) {
            ErrorLOGGER.error("", e);
        }
        return 0;

    }


    public void initDayLimitRedis(String raffleid){
        SimpleDateFormat sdf = new SimpleDateFormat("yyMMdd");
        String date = sdf.format(new Date());

        String result = redisService.get(date+"joinraffle"+raffleid);

        if(result == null || "".equals(result)){
            redisService.add(date+"joinraffle"+raffleid,"0");
        }

    }








    /**
     * 查询检验
     * @param vipInfo
     * @param config
     * @throws BussinessException
     */
    public void checkVipQuery(VipInfo vipInfo, ActivityLimitConfig config) throws BussinessException {

        this.checkAiqy20(vipInfo,config);
        comonService.checkTimestamp(vipInfo.getTimestamp());
        activityService.checkActivity(vipInfo);
        comonService.checkQueryVipSign(vipInfo);
        mobService.checkVipMob(vipInfo);
    }


    /**
     * 抽奖校验
     *
     * @param vipInfo
     * @throws BussinessException
     */
    public void checkVip(VipInfo vipInfo,ActivityLimitConfig config) throws BussinessException {
        this.checkRedis(vipInfo);
        this.checkAiqy20(vipInfo, config);
        comonService.checkTimestamp(vipInfo.getTimestamp());
        activityService.checkActivity(vipInfo);
        comonService.checkQueryVipSign(vipInfo);
        mobService.checkVipMob(vipInfo);
    }


    /**
     * 活动抽奖
     *
     * @param activityInfo
     * @throws BussinessException
     */
    public String givePrize(VipInfo activityInfo,ActivityLimitConfig config) throws BussinessException {
        String result="";
        this.queryVip(activityInfo);

        if("aiqy".equals(activityInfo.getCpid()) && "1018".equals(activityInfo.getSpid())){

            result = this.joinPrize(activityInfo, config);


        }else{
            throw new BussinessException("9088", "该cp暂未开放");
        }
        System.out.println("JoinInfo="+ JSON.toJSONString(activityInfo));
        return result;
    }


    /**
     *  抽奖
     * @param activityInfo
     * @param config
     * @return
     */
    public String joinPrize(VipInfo activityInfo,ActivityLimitConfig config)throws BussinessException{
        SimpleDateFormat sdf = new SimpleDateFormat("yyMMdd");
        String date = sdf.format(new Date());
        int count=config.getLimitcount();
        long redisDaycount = 0;
        String result = "4";
        //查看是否已参与抽奖
        int joincount = activeDao.getJoinActive(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype());
        if(joincount > 0) {
//            if("18673197465".equals(activityInfo.getUserid())){

//            }else{

                throw new BussinessException("6081", "已参与抽奖");
//            }
        }
        String province = activeDao.getOrderPrivince(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid());
        long redisAllcount = this.getRedis(config.getRediskey());
        if (redisAllcount >= count) {
            activeDao.insert(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype(), province,"未中奖", "4");
            result = "4";
            return result;
//            throw new BussinessException("0", "未中奖");
        }

        //抽奖

        int lucknumber = new Random().nextInt(200);
        if(lucknumber == 0){
            lucknumber++;
        }

        if(lucknumber >= 1 && lucknumber <=50){
            redisDaycount = this.getRedis(date+"joinraffle"+"1");
            if(redisDaycount >= 50){
                activeDao.insert(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype(), province,"未中奖", "4");
                result = "4";
                return result;
            }
            activeDao.insert(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype(), province,"鼠标垫", "1");
            this.addRedis(config.getRediskey());  //总抽中数+1
            this.addRedis(config.getRediskey()+"1");  //奖品1中奖数+1
            this.addRedis(date+"joinraffle"+"1");//当天奖品1中奖数+1
            result = "1";
            return result;
//            System.out.println("恭喜中了鼠标垫");
        }else if(lucknumber >= 51 && lucknumber <=91){
            redisDaycount = this.getRedis(date+"joinraffle"+"2");
            if(redisDaycount >= 41){
                activeDao.insert(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype(), province,"未中奖", "4");
                result = "4";
                return result;
            }
            activeDao.insert(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype(), province,"杯子", "2");
            this.addRedis(config.getRediskey());  //总抽中数+1
            this.addRedis(config.getRediskey()+"2");  //奖品2中奖数+1
            this.addRedis(date+"joinraffle"+"2");//当天奖品2中奖数+1
            result = "2";
            return result;
//            System.out.println("恭喜中了杯子");
        }else if(lucknumber >= 92 && lucknumber <=124){
            redisDaycount = this.getRedis(date+"joinraffle"+"3");
            if(redisDaycount >= 33){
                activeDao.insert(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype(), province,"未中奖", "4");
                result = "4";
                return result;
            }
            activeDao.insert(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype(), province,"手提袋", "3");
            this.addRedis(config.getRediskey());  //总抽中数+1
            this.addRedis(config.getRediskey()+"3");  //奖品3中奖数+1
            this.addRedis(date+"joinraffle"+"3");//当天奖品3中奖数+1
            result = "3";
            return result;
//            System.out.println("恭喜中了手提袋");
        }else{
            activeDao.insert(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype(), province,"未中奖", "4");
            result = "4";
            return result;
//            System.out.println("非常遗憾，未中奖");

        }
    }






    /**
     * 检查是否是爱奇艺抽奖活动且有效
     * @param vipInfo
     * @throws BussinessException
     */
    public void checkAiqy20(VipInfo vipInfo,ActivityLimitConfig config) throws BussinessException {
        String activetype=config.getActivetype();
        String activeend=config.getActiveendtime();

        if(!activetype.equals(vipInfo.getActivetype())){
            throw new BussinessException("9083", "该活动无效");
        }

        try {
            if(new SimpleDateFormat("yyyyMMddHHmmss").parse(activeend).getTime()<System.currentTimeMillis()){
                throw new BussinessException("9083", "该活动已经结束");
            }
        } catch (Exception e) {
            if (e instanceof BussinessException) {
                throw (BussinessException)e;
            }else{
                ErrorLOGGER.error("", e);
            }
        }
    }


    /**
     *
     * @param activityInfo
     * @throws BussinessException
     */
    public void queryVip(VipInfo activityInfo) throws BussinessException {
        //是否已经抽奖
        int joincount = activeDao.getJoinActive(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype());
        if(joincount > 0) {
//            if("18673197465".equals(activityInfo.getUserid())){

//            }else{

                throw new BussinessException("6081", "已参与抽奖");
//            }
        }

        //是否有效订购
        int ordercount = activeDao.getOrderRelation(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid());
        if(ordercount<=0){
            throw new BussinessException("6082", "用户不具备抽奖资格");
        }



    }




    public void checkRedis(VipInfo vipInfo) throws BussinessException {
        try {
            long count = redisService.incr("joinraffle_" + vipInfo.getActivetype() + "_" + vipInfo.getUserid());
            if (count > 1) {
                throw new BussinessException("8001", "并发请求，请稍后再试");
            }
        } catch (Exception e) {
            if (e instanceof BussinessException) {
                throw e;
            }else{
                ErrorLOGGER.error("", e);
            }
        }
    }



    /**
     * ip校验
     */
    public void checkIp(ActivityLimitConfig config)throws BussinessException {

        ServletRequestAttributes attributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
        HttpServletRequest request = attributes.getRequest();
        if(org.apache.commons.lang.StringUtils.isNotEmpty(config.getLimitip())) {
            System.out.println("ip============>"+config.getLimitip());
            List<String> list = Arrays.asList(config.getLimitip().split(","));
            System.out.println("listIP:"+list);
            String ip = IpAddrUtil.getIpAddr(request);
            System.out.println("ip:"+ip);
            if(!list.contains(ip)) {
                throw new BussinessException("10009", "ip地址校验失败"+ip);
            }
        }
    }

}
