package com.chinacreator.video.service;

import java.util.Date;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.time.DateFormatUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.chinacreator.video.bean.ActivityBean;
import com.chinacreator.video.bean.ActivityMsgBean;
import com.chinacreator.video.bean.VipWhiteBean;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.ActiveDao;
import com.chinacreator.video.mapper.DictionaryDao;
import com.chinacreator.video.mapper.GiveVipProvinceCrontrolDao;
import com.chinacreator.video.mapper.VipWhiteDao;

@Component
public class ActivityMsgService {

	@Autowired
	private ComonService comonService;

	@Autowired
	private MobService mobService;
	
	@Autowired
	private ActiveDao activeDao;
	
	@Autowired
	private GiveVipProvinceCrontrolDao giveVipProvinceCrontrolDao;
	
	@Autowired
	private VipWhiteDao vipWhiteDao;

	@Autowired
	private DictionaryDao dictionaryDao;
	
	@Autowired
	private EcbService ecbService;
	
	public void check(ActivityMsgBean activityMsgBean) throws BussinessException {
		if (activityMsgBean == null) {
			throw new BussinessException("9050", "参数为空");
		}
		comonService.checkTimestamp(activityMsgBean.getTimestamp());
		comonService.checkGetMsgSign(activityMsgBean);
		mobService.checkMsgMob(activityMsgBean);
	}
	
	public void checkRecive(ActivityMsgBean activityMsgBean) throws BussinessException {
		if (activityMsgBean == null) {
			throw new BussinessException("9050", "参数为空");
		}
		if(StringUtils.isEmpty(activityMsgBean.getUserid()) || StringUtils.isEmpty(activityMsgBean.getCpid()) || StringUtils.isEmpty(activityMsgBean.getSpid())) {
			throw new BussinessException("9050", "参数错误");
		}
	}
	
	public void revice(ActivityMsgBean activityMsgBean) throws BussinessException {
		String activityType = "13";
		ActivityBean activityBean = activeDao.getActivityInfo(activityMsgBean.getUserid(),activityMsgBean.getCpid(), activityMsgBean.getSpid(), activityType);
		if(activityBean==null) {
			throw new BussinessException("9085", "用户无订购不能赠送会员");
		}
		if(activityMsgBean.getType().equals("0")) {
			if(!activityBean.getVipstatus().equals("3")) {
				throw new BussinessException("9085", "用户会员赠送状态错误");
			}
			activityBean.setVipstatus(activityMsgBean.getGivestatus());
			activeDao.updateVip(activityBean);
		}else if(activityMsgBean.getType().equals("1")) {
			if(activityBean.getVipconstatus()== null || !activityBean.getVipconstatus().equals("2")) {
				throw new BussinessException("9085", "用户会员续送送状态错误");
			}
			activityBean.setVipconstatus(activityMsgBean.getGivestatus());
			activeDao.updateContimueVip(activityBean);
		}
	}

	public void giveMsg(ActivityMsgBean activityMsgBean) throws BussinessException {
		String activityType = "13";
		VipWhiteBean vipWhiteBean = vipWhiteDao.getCount("0", activityMsgBean.getUserid(),activityMsgBean.getCpid(),activityMsgBean.getSpid());
		if(vipWhiteBean != null && vipWhiteBean.getType().equals("1")) {
			throw new BussinessException("9089", "黑名单用户禁止领取");
		}
		ActivityBean activityBean = activeDao.getActivityInfo(activityMsgBean.getUserid(),activityMsgBean.getCpid(), activityMsgBean.getSpid(), activityType);
		if(activityBean==null) {
			throw new BussinessException("9085", "用户无订购不能赠送会员");
		}
		if(activityBean.getOrderstatus().equals("1") && NumberUtils.toLong(activityBean.getEndtime())<NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"))) {
			throw new BussinessException("9084", "用户为无效订购状态不能赠送会员");
		}
		String cangive = giveVipProvinceCrontrolDao.queryProvinceCrontrol(activityMsgBean.getCpid(), activityMsgBean.getSpid(), activityBean.getProvince(), activityBean.getActiveType());
		if(!cangive.equals("0")) {
			throw new BussinessException("9098", "该省份会员被限制领取");
		}
		if(activityBean.getVipstatus().equals("0")) {
			throw new BussinessException("9087", "会员已领取");
		}
		if(activityBean.getVipstatus().equals("3")) {
			throw new BussinessException("8007", "会员正在赠送/续送中");
		}
		ecbService.queryEcb(activityMsgBean.getUserid(), activityMsgBean.getCpid(), activityMsgBean.getSpid(), "");
		activityBean.setVipstatus("3");
		activeDao.updateVip(activityBean);
	}

	public void giveContinueMsg(ActivityMsgBean activityMsgBean) throws BussinessException {
		String activityType = "13";
		String str = dictionaryDao.getValue("continuetime");
		if(NumberUtils.toInt(DateFormatUtils.format(new Date(), "dd"))!=NumberUtils.toInt(str)) {
			throw new BussinessException("9081", "不在续送时间范围");
		}
		VipWhiteBean vipWhiteBean = vipWhiteDao.getCount("0", activityMsgBean.getUserid(),activityMsgBean.getCpid(),activityMsgBean.getSpid());
		if(vipWhiteBean != null && vipWhiteBean.getType().equals("1")) {
			throw new BussinessException("9089", "黑名单用户禁止领取");
		}
		ActivityBean activityBean = activeDao.getActivityInfo(activityMsgBean.getUserid(),activityMsgBean.getCpid(), activityMsgBean.getSpid(), activityType);
		if(activityBean==null) {
			throw new BussinessException("9085", "用户无订购不能赠送会员");
		}
		if(activityBean.getOrderstatus().equals("1") && NumberUtils.toLong(activityBean.getEndtime())<NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"))) {
			throw new BussinessException("9084", "用户为无效订购状态不能赠送会员");
		}
		if (StringUtils.isNotEmpty(activityBean.getVipconstatus()) && activityBean.getVipconstatus().equals("0") && NumberUtils.toLong(activityBean.getVipcontime().substring(0, 6))==NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMM"))) {
			throw new BussinessException("9083", "本月已续送会员");
		}
		if(NumberUtils.toLong(activityBean.getOrdertime().substring(0, 6))>NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMM"))) {
			throw new BussinessException("9082", "本月只能赠送会员不能续送");
		}
		if(activityBean.getVipconstatus()!= null && activityBean.getVipconstatus().equals("2")) {
			throw new BussinessException("8007", "会员正在赠送/续送中");
		}
		ecbService.queryEcb(activityMsgBean.getUserid(), activityMsgBean.getCpid(), activityMsgBean.getSpid(), "");
		activityBean.setVipconstatus("2");
		activeDao.updateContimueVip(activityBean);
	}

}
