package com.chinacreator.video.service;


import java.net.URLEncoder;
import java.util.Date;
import java.util.Map;
import java.util.TreeMap;

import org.apache.commons.lang.time.DateFormatUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.VipLog;
import com.chinacreator.video.mapper.SysDao;
import com.chinacreator.video.mapper.VipDao;
import com.chinacreator.video.util.MD5;
import com.chinacreator.video.util.URLUtil;

@Component
public class AiqiyiGiveMonthVipService {
	
	//正式
//	private static final String VIPURL = "https://data.tvguo.tv/coop/addOrder";
	private static final String VIPURL = "https://tvguo-api.iqiyi.com/coop/addOrder";
	
//	private static final String KEY = "NJH6CshP9A2U";
//	private static final  String PARTNERKEY = "scKDnzUKL&zeT&";
	
//	private static final String KEY_31 = "wgwZS1Icti0v";
//	private static final String PARTNERKEY_31 = "EjIKFQPdiwTLxW";
	
	private static final String KEY_31 = "bs07xckHhP9A2U";
	private static final String PARTNERKEY_31 = "partnerKeyJZMonth";
	
	private static final String PRODUCTID = "1";
	
	private static final  Logger log = LoggerFactory.getLogger("viplog");
	
	@Autowired
	private SysDao sysDao;
	
	@Autowired
	private VipDao vipDao;
	
	@Autowired
	VipControlService vipControlService;

	@Autowired
	ComplementSendService complementSendService;
	
	public void give(VipInfo activityInfo) throws BussinessException {
		vipControlService.canGiveVip(activityInfo);
		VipLog vipLog = new VipLog();
		vipLog.setResultcode("0");
		vipLog.setErrorinfo("");
		vipLog.setChannel(activityInfo.getChannel());
		vipLog.setActivityType(activityInfo.getActivetype());
		vipLog.setUserid(activityInfo.getUserid());
		vipLog.setType(activityInfo.getType());
		
		//订单重试
		boolean flagCorp=false;
		String toCorpOrderid=null;
		if(activityInfo.getVippool()!=null && !"".equals(activityInfo.getVippool().trim())){
			toCorpOrderid =  vipDao.getOrderId2(activityInfo.getUserid(), activityInfo.getActivetype(),activityInfo.getVippool());
		}else{
			toCorpOrderid =  vipDao.getOrderId(activityInfo.getUserid(), activityInfo.getActivetype());
		}
		if(toCorpOrderid != null && !"".equals(toCorpOrderid)){
			flagCorp=true;
		}
		
		try {
			Map<String,Object> map = new TreeMap<String, Object>();
			
			//重试订单
			String order_id = null;
			if(flagCorp){
				order_id = toCorpOrderid;
			}else{
				order_id = DateFormatUtils.format(new Date(), "yyyyMMddHHmmssSSS"+"_"+activityInfo.getUserid());
			}
			
			map.put("serialNo", order_id);
			vipLog.setOrderid(order_id);
			switch (activityInfo.getUsertype()) {
			case "4":
				break;
			default:
				throw new BussinessException("9072", "赠送会员失败usertype错误");
			}
			vipLog.setUsertype(activityInfo.getUsertype());
			map.put("mobile", activityInfo.getUserval());
			String time = DateFormatUtils.format(new Date(), "yyyyMMdd");
			
			time = order_id.substring(0,8);
			
			map.put("time", time);
			vipLog.setUserval(activityInfo.getUserval());
			vipLog.setVipdays("31");
			String begintime = sysDao.getSysTime();
			vipLog.setBegintime(begintime);
			map.put("productId", PRODUCTID);
			String endtime = sysDao.getLastDay();
			vipLog.setEndtime(endtime);
			map.put("partnerKey", PARTNERKEY_31);
			String signature = MD5.MD5Encode(getSign(map));
			map.put("sign", signature);
			String urldata =null;
			
			//发起请求
			String result=null;
			boolean flag9070=false;
			try {
				urldata = VIPURL+"?serialNo="+map.get("serialNo")+"&mobile="+map.get("mobile")+"&time="+map.get("time")+"&productId="+map.get("productId")+"&partnerKey="+URLEncoder.encode((String)map.get("partnerKey"),"utf-8")+"&sign="+map.get("sign");
				vipLog.setOutput(JSON.toJSONString(map));
				result =URLUtil.get(urldata);
				//result = "{\"code\":\"A00000\",\"msg\":\"订单生成成功！\"}";
				vipLog.setReturnput(result);
			}catch(Exception e) {
				flag9070=true;
			}
			JSONObject obj = JSON.parseObject(result);
			
			//主动重试
			if(flag9070 || result == null || obj==null || obj.get("code")==null){
				log.info(JSON.toJSONString(vipLog));
				try {
					result = URLUtil.get(urldata);
					vipLog.setReturnput(result);
					obj = JSON.parseObject(result);
				} catch (Exception e) {
					vipLog.setResultcode("9070");
					vipLog.setErrorinfo("赠送会员超时或者异常");
					throw new BussinessException("9070", "赠送会员超时或者异常");
				}
				
				//两次都返回-100的问题，就给前台返回9070，让用户发起重试  {\"ret\":-100}
				if(obj==null || obj.get("code")==null){
					vipLog.setResultcode("9070");
					vipLog.setErrorinfo("赠送会员超时或者异常");
					throw new BussinessException("9070", "赠送会员超时或者异常");
				}
			}
			
			//解析返回结果
			String msg = obj.getString("msg");
			String code = obj.getString("code");
			if("0".equals(code)){
				code="-0";
			}
			
			//订单是否成功
			boolean flagvip = false;
			if("A00000".equals(code) || "A00002".equals(code)){
				flagvip=true;
			}
			
			try {
				//把原有的9070订单标记失败
				if(flagCorp && flagvip && vipDao.getCount9070(activityInfo.getUserid(), toCorpOrderid)>0){
					vipDao.updateOrderIdAll(activityInfo.getUserid(), toCorpOrderid, "1","订单重试表明：此订单失败");
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			vipLog.setResultcode(flagvip?"0":code);
			vipLog.setErrorinfo(msg);

			complementSendService.updateJoinAccount(activityInfo,vipLog.getResultcode(),msg,order_id);
			vipControlService.saveVipGive(activityInfo, flagvip?"0":"1");
			if(!flagvip) {
				throw new BussinessException("9071", "赠送会员失败:"+obj.getString("msg"));
			}
		}catch(Exception e) {
			throw e;
		}finally {
			log.info(JSON.toJSONString(vipLog));
			saveLog(vipLog);
		}
	}
	
	public void saveLog(VipLog vipLog) {
		//vipLog.setResultcode("1");
		
		if(vipLog.getReturnput()==null){
			vipLog.setReturnput("");
		}
		if(vipLog.getResultcode()==null){
			vipLog.setResultcode("-0");
		}
		if(vipLog.getErrorinfo()==null){
			vipLog.setErrorinfo("");
		}
		vipDao.insert(vipLog);
	}
	
	public String getSign(Map<String,Object> map ) {
		if(map == null) {
			return "";
		}
		StringBuilder strb = new StringBuilder();
		for (String  pama : map.keySet()) {
			strb.append("&"+pama+"="+map.get(pama));
		}
		strb.deleteCharAt(0);
		strb.append(KEY_31);
		System.out.println("aqiyisign="+strb.toString());
		return strb.toString();
	}

}
