package com.chinacreator.video.service;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.chinacreator.video.mapper.DictionaryDao;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.time.DateFormatUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.alibaba.fastjson.JSON;
import com.chinacreator.video.bean.ActivityBean;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.ActiveDao;
import com.chinacreator.video.mapper.OrderDao;
import com.chinacreator.video.util.URLUtil;

@Component
public class CctvActivityService {

	@Autowired
	private OrderDao orderDao;
	
	@Autowired
	private ActiveDao activeDao;

	@Autowired
	private DictionaryDao dictionaryDao;
	public void activity(OrderInfo orderInfo,String type) throws Exception {
		orderInfo.setActivetype("8");
		ActivityBean activityBean = activeDao.getActivityInfo(orderInfo.getUserid(), orderInfo.getCpid(), orderInfo.getSpid(), orderInfo.getActivetype());
		getOrderInfo(orderInfo);
		if(activityBean == null) {
			activeDao.insert(getActivityBean(orderInfo));
		}else {
			ActivityBean newactivityBean = getActivityBean(orderInfo);
			getVipInfo(activityBean,type);
			newactivityBean.setId(activityBean.getId());
			newactivityBean.setVipstatus(activityBean.getVipstatus());
			newactivityBean.setViptime(activityBean.getViptime());
			System.out.println(JSON.toJSONString(newactivityBean));
			activeDao.update(newactivityBean);
		}
	}
	
	public void getVipInfo(ActivityBean activityBean,String type) throws BussinessException{
		 String vipstatus=activityBean.getVipstatus();
		 String viptime = activityBean.getViptime();
		 if(StringUtils.isEmpty(viptime)){
			 vipstatus = activityBean.getVipstatus();
			 viptime = activityBean.getViptime();
		 }else{
			 if(NumberUtils.toLong(viptime.substring(0, 6)) ==NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMM"))){
				 if(activityBean.getVipcontime() != null && NumberUtils.toLong(activityBean.getVipcontime().substring(0, 6))  == NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMM"))){
					 vipstatus ="0";
					 viptime = activityBean.getViptime();
				 }else{
					 vipstatus = activityBean.getVipstatus();
					 viptime = activityBean.getViptime();
				 }
			 }else if(NumberUtils.toLong(viptime.substring(0, 6)) < NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMM"))){
				if(type.equals("0")) {
					vipstatus ="2";
					 viptime ="";
				}else {
					 vipstatus = activityBean.getVipstatus();
					 viptime = activityBean.getViptime();
				}
			 }else{
				 throw new BussinessException("8010", "viptime数据异常");
			 }
		 }
		 activityBean.setVipstatus(vipstatus);
		 activityBean.setViptime(viptime);
	}
	
	public ActivityBean getActivityBean(OrderInfo orderInfo) {
		ActivityBean bean = new ActivityBean();
		bean.setUserid(orderInfo.getUserid());
		bean.setCpid(orderInfo.getCpid());
		bean.setSpid(orderInfo.getSpid());
		bean.setProvince(orderInfo.getProvince());
		bean.setOrdertime(orderInfo.getOrdertime());
		bean.setArea(orderInfo.getArea());
		bean.setCanceltime(orderInfo.getCanceltime());
		bean.setOrderchannel(orderInfo.getOrderchannel());
		bean.setCancelchannel(orderInfo.getCancelchannel());
		bean.setEndtime(orderInfo.getEndtime());
		bean.setActiveType(orderInfo.getActivetype());
		bean.setOrderstatus(orderInfo.getOrderstatus()+"");
		System.out.println(JSON.toJSONString(bean));
		return bean;
	}
	
	public void getOrderInfo(OrderInfo orderInfo) throws Exception{
		List<OrderInfo> list = orderDao.getOrderByUseridCpid(orderInfo.getUserid(), orderInfo.getCpid());
		 List<OrderInfo> orderlist = new ArrayList<OrderInfo>();
		 List<OrderInfo> cancellist = new ArrayList<OrderInfo>();
		 if(list != null && list.size()>0){
			 for (OrderInfo listOrderInfo : list) {
				 System.out.println(JSON.toJSONString(listOrderInfo));
				if(listOrderInfo.getStatus()==0){
					orderlist.add(listOrderInfo);
				}else if(listOrderInfo.getStatus()==1){
					cancellist.add(listOrderInfo);
				}
			}
		 }
		 String ordertime ="";
		 String endtime="";
		 String canceltime="";
		 String orderstatus= "";
		 String orderchannel ="";
		 String cancelchannel="";
		 if(orderlist.size()>0 && cancellist.size()==0){//全是订购，取最早订购时间
			 orderstatus = "0";
			 for (OrderInfo orderOrderBean : orderlist) {
				if(StringUtils.isEmpty(ordertime)){
					ordertime = orderOrderBean.getOrdertime();
				}
				if(NumberUtils.toLong(orderOrderBean.getOrdertime()) <= NumberUtils.toLong(ordertime)){
					ordertime = orderOrderBean.getOrdertime();
					orderchannel = orderOrderBean.getOrderchannel();
				}
			}
		 }else if(cancellist.size() >0 && orderlist.size()==0){
			 orderstatus ="1";
			 for (OrderInfo cancelOrderBean : cancellist) {
					if(StringUtils.isEmpty(ordertime)){
						ordertime = cancelOrderBean.getOrdertime();
						canceltime = cancelOrderBean.getCanceltime();
					}
					if(NumberUtils.toLong(cancelOrderBean.getOrdertime()) <= NumberUtils.toLong(ordertime)){
						ordertime = cancelOrderBean.getOrdertime();
						orderchannel = cancelOrderBean.getOrderchannel();
					}
					if(NumberUtils.toLong(cancelOrderBean.getCanceltime()) >= NumberUtils.toLong(canceltime)){
						canceltime = cancelOrderBean.getCanceltime();
						endtime = cancelOrderBean.getEndtime();
						cancelchannel = cancelOrderBean.getCancelchannel();
					}
				}
		 }else if(cancellist.size() >0 && orderlist.size()>0){
			 orderstatus ="0";
			 for (OrderInfo allOrderBean : list) {
				 if(allOrderBean.getStatus()==0 || allOrderBean.getStatus()==1){
					 if(StringUtils.isEmpty(ordertime)){
							ordertime = allOrderBean.getOrdertime();
						}
					 if(NumberUtils.toLong(allOrderBean.getOrdertime()) <= NumberUtils.toLong(ordertime)){
							ordertime = allOrderBean.getOrdertime();
							orderchannel=allOrderBean.getOrderchannel();
						}
				 }
			 }
		 }else{
			 throw new BussinessException("8010", "order数据异常");
		 }
		 orderInfo.setEndtime(endtime);
		 orderInfo.setCanceltime(canceltime);
		 orderInfo.setOrderstatus(Integer.valueOf(orderstatus));
		 orderInfo.setOrdertime(ordertime);
		 orderInfo.setOrderchannel(orderchannel);
		 orderInfo.setCancelchannel(cancelchannel);
	} 
	
	public void insertCctvMq(OrderInfo orderInfo,String type) {
	    try {
	      Map<String,String> map = new HashMap<String,String>();
	      map.put("userid", orderInfo.getUserid());
	      map.put("cpid", orderInfo.getCpid());
	      map.put("spid", "10081");
	      map.put("province", orderInfo.getProvince());
	      map.put("area", orderInfo.getArea());
	      if (type.equals("0")) {
	        map.put("status", "0");
	        map.put("ordertime", DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"));
	        map.put("canceltime", "");
	        map.put("orderchannel", orderInfo.getOrderchannel());
	        map.put("cancelchannel", "");
	      } else {
	        map.put("status", "1");
	        map.put("ordertime", "");
	        map.put("canceltime", DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"));
	        map.put("orderchannel", "");
	        map.put("cancelchannel", orderInfo.getCancelchannel());
	      }
	      map.put("videoid", "");
	      map.put("type", "vacOrder");
			String  mqReciveUrl = dictionaryDao.getValue("mqReciveUrl");
	      URLUtil.post(mqReciveUrl, JSON.toJSONString(map));
	    } catch (Exception e) {
	      e.printStackTrace();
	    }
	  }
}
