package com.chinacreator.video.service;

import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.AreaDao;

@Component
public class ChannelOrderService {

	@Autowired
	private ComonService comonService;
	
	@Autowired
	private ChannelValidate channelValidate;
	
	@Autowired
	private CpSpService cpSpService;
	
	@Autowired
	private MobService mobService;
	
	@Autowired
	private OrderService orderService;
	
	@Autowired
	private AreaDao areaDao;
	
	public void orderValidate(OrderInfo orderInfo) throws BussinessException {
		comonService.checkTimestamp(orderInfo.getTimestamp());
		channelValidate.validate(orderInfo.getChannel());
		comonService.checkSignChannel(orderInfo);
		cpSpService.checkSp(orderInfo);
		mobService.checkChannelMob(orderInfo);
		Map<String,String> map = areaDao.getArea(orderInfo.getUserid());
		if(map != null) {
			orderInfo.setProvince(map.get("province") == null ? "" : map.get("province"));
			orderInfo.setArea(map.get("area") == null ? "" : map.get("area"));
		}
		//省份限制验证
		comonService.valiProvinceLimit(orderInfo);
	}
	
	public void channelOrder(OrderInfo orderInfo) throws Exception {
		if(orderInfo.getSpid().equals("84")) {
			orderInfo.setSpid("101");
			orderInfo.setOrdertype(1);
		}
		orderService.order(orderInfo);
	}
	
	public void channelCancel(OrderInfo orderInfo) throws Exception {
		if(orderInfo.getSpid().equals("84")) {
			orderInfo.setSpid("101");
			orderInfo.setCanceltype(1);
		}
		orderService.cancel(orderInfo);
	}
}
