package com.chinacreator.video.service;


import java.util.HashMap;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.VipLog;
import com.chinacreator.video.mapper.SysDao;
import com.chinacreator.video.mapper.VipDao;
import com.chinacreator.video.util.MD5;
import com.chinacreator.video.util.URLUtil;

@Component
public class CtvGiveVipService {

	//测试
	//private static final String VIPURL = "http://202.108.16.147:8080/user/member/sync/1011";
	
	private static final String VIPURL = "http://ptnr.m.cctv4g.com/user/member/sync/1011";
	
	private static final String KEY = "28cce6ba45c14a37b5f0fe0098135155";
	
	private static final  Logger log = LoggerFactory.getLogger("viplog");
	
	@Autowired
	private SysDao sysDao;
	
	@Autowired
	private VipDao vipDao;
	
	@Autowired
	VipControlService vipControlService;

	@Autowired
	ComplementSendService complementSendService;
	
	public void   give(VipInfo activityInfo) throws BussinessException {
		vipControlService.canGiveVip(activityInfo);
		VipLog vipLog = new VipLog();
		vipLog.setResultcode("0");
		vipLog.setErrorinfo("");
		vipLog.setActivityType(activityInfo.getActivetype());
		vipLog.setUserid(activityInfo.getUserid());
		vipLog.setType(activityInfo.getType());
		
		//订单重试
        boolean flagCorp=false;
        String toCorpOrderid=null;
        if(activityInfo.getVippool()!=null && !"".equals(activityInfo.getVippool().trim())){
        	toCorpOrderid =  vipDao.getOrderId2(activityInfo.getUserid(), activityInfo.getActivetype(),activityInfo.getVippool());
        }else{
        	toCorpOrderid =  vipDao.getOrderId(activityInfo.getUserid(), activityInfo.getActivetype());
        }
        if(toCorpOrderid != null && !"".equals(toCorpOrderid)){
        	flagCorp=true;
        }
		
		try {
			Map<String,Object> map = new HashMap<String, Object>();
			
			//重试订单
            String order_id = null;
            if(flagCorp){
            	order_id = toCorpOrderid;
            }else{
            	order_id = this.sysDao.getId();
            }
			
			map.put("seq", order_id);
			vipLog.setOrderid(order_id);
			switch (activityInfo.getUsertype()) {
			case "4":
				break;
			default:
				throw new BussinessException("9072", "赠送会员失败usertype错误");
			}
			vipLog.setUsertype(activityInfo.getUsertype());
			map.put("mobile", activityInfo.getUserval());
			vipLog.setUserval(activityInfo.getUserval());
			vipLog.setVipdays("31");
			String begintime = sysDao.getSysTime();
			vipLog.setBegintime(begintime);
			String endtime = sysDao.getLastDay();
			vipLog.setEndtime(endtime);
			String signature = MD5.MD5Encode(activityInfo.getUserval()+order_id+KEY);
			map.put("sign", signature);
			map.put("oper", "5");
			
			String result=null;
			try {
				vipLog.setOutput(JSON.toJSONString(map));
				result =URLUtil.get(VIPURL+"?seq="+map.get("seq")+"&mobile="+map.get("mobile")+"&sign="+map.get("sign")+"&oper="+map.get("oper"));
				//result = "{\"plat\":\"1011\",\"seq\":\"201807041444083738526\",\"rcode\":\"0000\",\"msg\":\"处理成功\"}";
				vipLog.setReturnput(result);
			}catch(Exception e) {
				vipLog.setResultcode("9070");
				vipLog.setErrorinfo("赠送会员超时或者异常");
				throw new BussinessException("9070", "赠送会员超时或者异常");
			}
			JSONObject obj = JSON.parseObject(result);
			
			//解析返回结果
			String msg = obj.getString("msg");
			String code = obj.getString("rcode");
			if("0".equals(code)){
				code="-0";
			}
			
			//订单是否成功
			boolean flagvip = false;
			if("0000".equals(code)){
				flagvip=true;
			}
			
			try {
				//把原有的9070订单标记失败
				if(flagCorp && flagvip && vipDao.getCount9070(activityInfo.getUserid(), toCorpOrderid)>0){
					vipDao.updateOrderIdAll(activityInfo.getUserid(), toCorpOrderid, "1","订单重试表明：此订单失败");
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			vipLog.setResultcode(flagvip?"0":code);
			vipLog.setErrorinfo(msg);

			// 更新账期
			complementSendService.updateJoinAccount(activityInfo,vipLog.getResultcode(),msg,order_id);

			vipControlService.saveVipGive(activityInfo, vipLog.getResultcode());
			if(!flagvip) {
				throw new BussinessException("9071", "赠送会员失败:"+obj.getString("msg"));
			}
		}catch(Exception e) {
			throw e;
		}finally {
			log.info(JSON.toJSONString(vipLog));
			saveLog(vipLog);
		}
	}
	
	public void saveLog(VipLog vipLog) {
 		//vipLog.setResultcode("1");
		
		if(vipLog.getReturnput()==null){
			vipLog.setReturnput("");
		}
		if(vipLog.getResultcode()==null){
			vipLog.setResultcode("-0");
		}
		if(vipLog.getErrorinfo()==null){
			vipLog.setErrorinfo("");
		}
		vipDao.insert(vipLog);
	}
	
	public static void main(String[] args) throws Exception {
		CtvGiveVipService service = new CtvGiveVipService();
		VipInfo activityInfo = new VipInfo();
		activityInfo.setUsertype("1");
		activityInfo.setUserval("306581007");
		service.give(activityInfo);
	}

}
