package com.chinacreator.video.service;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.DictionaryDao;
import com.chinacreator.video.util.URLUtil;

@Component
public class EcbBalanceService {
	

	@Autowired
	private DictionaryDao dictionaryDao;
	
	public void queryEcbBalance(String userid, String cpid, String spid, String province) throws BussinessException {
		System.out.println("余额查询接口："+userid+",     "+cpid+",     "+spid+",     "+province);
		if(cpid.equals("tencent") && spid.equals("84") && StringUtils.isNotEmpty(province) && province.equals("云南")) {
			  String result = null;
		      try {
		        result = URLUtil.get(
		          dictionaryDao.getValue("ecbBalanceUrl") + "?userid=" + userid + "&cpid=" + cpid + "&spid=" + spid, 
		          NumberUtils.toInt(dictionaryDao.getValue("ecbTimeout")));
//		    	  result ="{\"resultCode\":\"0\"}";
		      } catch (Exception e) {
		        e.printStackTrace();
		      }
		      if (result == null) {
		    	 throw new BussinessException("9072", "用户余额查询失败");
		        }
		      System.out.println("用户余额查询："+result);
		      JSONObject obj = JSON.parseObject(result);
	          if (!obj.get("resultCode").toString().equals("0")) {
	            throw new BussinessException(obj.get("resultCode").toString(),obj.getString("errorInfo"));
	          }
	          String balance = obj.getString("balance");
	          if(!NumberUtils.isNumber(balance)) {
	        	  throw new BussinessException("9073", "用户余额查询结果异常");
	          }
	          System.out.println("余额查询接口："+NumberUtils.toLong(balance)/100);
	          if((NumberUtils.toLong(balance)/100) < 20) {
	        	  throw new BussinessException("9074", "用户余额不足");
	          }
		}
	}
}
