package com.chinacreator.video.service;
import com.chinacreator.video.mapper.EcbOrderWhiteDao;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.ECBBean;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.DictionaryDao;
import com.chinacreator.video.mapper.ECBConfigDao;
import com.chinacreator.video.util.URLUtil;

@Component
public class EcbService {

	@Autowired
	private ECBConfigDao ecbConfigDao;

	@Autowired
	private DictionaryDao dictionaryDao;

	@Autowired
	private EcbOrderWhiteDao ecbOrderWhiteDao;
    
	/**
	 * 三户套餐判断
	 * @param userid
	 * @param cpid
	 * @param spid
	 * @param province
	 * @return 品牌
	 * @throws BussinessException
	 */
	public String queryEcb(String userid, String cpid, String spid, String province) throws BussinessException {
		String brand = ""; //用户品牌
		ECBBean bean = ecbConfigDao.queryEcbConfig(cpid, spid, province);
		//20220517 将三户限制去掉 can.he  bean = null;
		bean = null;
		if(bean != null && bean.getStatus() == 0) {
			  String result = null;
		      try {
		    	  result = URLUtil.get(
		          dictionaryDao.getValue("ecbUrl") + "?userid=" + userid + "&cpid=" + cpid + "&spid=" + spid,
		          NumberUtils.toInt(dictionaryDao.getValue("ecbTimeout")));
 		    	  //result ="{\"errorInfo\":\"\",\"resultCode\":\"0\",\"pacakge\":\"[POL064]新4G沃享流量王29档\"}";
		      } catch (Exception e) {
		    	  throw new BussinessException("8006","调用三户套查询接口失败");
		      }
		      if (result == null) {
		    	  throw new BussinessException("8006","调用三户套查询接口失败null");
		      }
	    	  JSONObject obj = JSON.parseObject(result);
	          if ((!obj.get("resultCode").toString().equals("0")) 
	        		  && (!obj.get("resultCode").toString().equals("10003"))) {
	        	  	String errorInfo = "用户三户查询结果异常";
	        	  	throw new BussinessException(obj.get("resultCode").toString(),errorInfo);
	          }
	          //判断是否4G用户
	          if(obj.get("brand") != null && !"".equals(obj.get("brand"))){
	          	  brand = obj.get("brand").toString();
	          }
	          if(StringUtils.isNotEmpty(bean.getLimit()) && obj.get("pacakge") != null && StringUtils.isNotEmpty(obj.get("pacakge").toString())) {
		    	  	String[] strLimt = bean.getLimit().split("\\|\\|");
		    	  	if(strLimt != null && strLimt.length>0) {
		    	  		for (String string : strLimt) {
		    	  			if(obj.get("pacakge").toString().contains(string.replaceAll("\\*", ""))) {
		    	  				if(this.ecbOrderWhiteDao.queryEcbJoinWhite(cpid,spid,province,userid)){
		    	  					//是白名单
		    	  				}else{
		    	  					throw new BussinessException("10004","三户套餐限制");
		    	  				}
		    	  			}
		    	  		}
		    	  	}
		      }
		}
		
		return brand;
	}

//	public static void main(String[] args) {
//		String str = "{\"errorInfo\":\"\",\"resultCode\":\"0\",\"pacakge\":\"畅爽冰激凌套餐108元档（湖南）\"}";
//
//	}
}
