package com.chinacreator.video.service;

import java.util.List;
import java.util.Map;

import com.chinacreator.video.mapper.EcbJoinWhiteDao;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.ECBJoinBean;
import com.chinacreator.video.bean.ECBLogTempBean;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.DictionaryDao;
import com.chinacreator.video.mapper.ECBJoinConfigDao;
import com.chinacreator.video.mapper.ECBLogTempDao;
import com.chinacreator.video.util.URLUtil;

/**
 * 赠送会员及续送会员判断是否黑名单
 * @author xu.zhou
 * @date 20190219
 */
@Component
public class EcbVipService {
	@Autowired
	private ECBJoinConfigDao ecbJoinConfigDao;

	@Autowired
	private DictionaryDao dictionaryDao;
	
	@Autowired
	private EcbJoinWhiteDao ecbJoinWhiteDao;
	@Autowired
	private ECBLogTempDao eCBLogTempDao;
	
	public void queryEcb(String userid, String cpid, String spid, String province, int type, String activetype) throws BussinessException {
		System.out.println(userid+"=="+cpid+"=="+spid+"=="+province+"=="+activetype);
		boolean isWhite=ecbJoinWhiteDao.queryEcbJoinWhite(cpid,spid,province,activetype,userid)>0 ?true:false;
		  //查询是否配置黑名单套餐限制
		ECBJoinBean	bean = ecbJoinConfigDao.queryEcbJoinConfig(cpid, spid, province, activetype);
		//20220517 将三户限制去掉 can.he  bean = null;
		bean = null;
		//System.out.println("========================ECBJoinBean:"+bean);
		if(bean != null && bean.getStatus() == 0) {
			   //System.out.println("+++++++++++++"+bean.getBrandlimit()+" >>>>>>>>>>>> "+bean.getLimit());
			   List list = eCBLogTempDao.queryEcbTemp(userid, cpid, spid);
			   //System.out.println("++++++++++++++++list:"+list.size());
			   if(type == 1){ //续送会员
				   if(list != null && list.size()>0){
					   Map beanMap = (Map)list.get(0);
					   //System.out.println("续送会员+++++++++++++++beanMap:"+beanMap.get("PACAKGE")+" "+beanMap.get("BRAND"));
					   if("0".equals(beanMap.get("RESULTCODE"))){//查询成功
						   //有套餐信息
						   if(beanMap.get("PACAKGE") != null && !"".equals(beanMap.get("PACAKGE")) && StringUtils.isNotEmpty(bean.getLimit())){
							   String pacakge = beanMap.get("PACAKGE").toString();
					    	   String[] strLimt = bean.getLimit().split("\\|\\|");
					    	   if(strLimt != null && strLimt.length>0) {
					    		  for (String string : strLimt) {
									if(pacakge.contains(string.replaceAll("\\*", ""))) {
										if(!isWhite) {
											//不存在白名单抛出异常
											throw new BussinessException("20006", "续送会员三户套餐限制");
										}
									}
								  }
					    	  }						    
						   }
						   //有品牌信息
						   if(beanMap.get("BRAND") != null && !"".equals(beanMap.get("BRAND")) && StringUtils.isNotEmpty(bean.getBrandlimit())){
							   String brand = beanMap.get("BRAND").toString();
					    	   String[] strLimt = bean.getBrandlimit().split("\\|\\|");
					    	   if(strLimt != null && strLimt.length>0) {
					    		  for (String string : strLimt) {
									if(brand.contains(string.replaceAll("\\*", ""))) {
										if(!isWhite) {
											//不存在白名单抛出异常
											throw new BussinessException("20007", "续送会员三户品牌限制");
										}
									}
								  }
					    	   }						    
						   } 
					   }else{//日志记录查询失败，返回错误信息
						   throw new BussinessException("20005","续送会员ECB三户套餐查询日志为失败状态");
					   }
				   }else{//无ECB三户查询记录，返回错误
					   //20190311改为不做限制，因为无历史数据
					   //throw new BussinessException("20004","续送会员无ECB三户套餐查询记录");
				   }
			   }else{//领取会员
				   if(list != null && list.size()>0){//有三户查询记录
					   Map beanMap = (Map)list.get(0);
					   //System.out.println("续送会员+++++++++++++++beanMap:"+beanMap.get("PACAKGE")+" "+beanMap.get("BRAND"));
					   if("0".equals(beanMap.get("RESULTCODE"))){//查询成功
						   //有套餐信息
						   if(beanMap.get("PACAKGE") != null && !"".equals(beanMap.get("PACAKGE")) && StringUtils.isNotEmpty(bean.getLimit())){
							     String pacakge = beanMap.get("PACAKGE").toString();
						    	 String[] strLimt = bean.getLimit().split("\\|\\|");
						    	 if(strLimt != null && strLimt.length>0) {
						    		 for (String string : strLimt) {
										if(pacakge.contains(string.replaceAll("\\*", ""))) {
											//查询是否有从黑名单提取出来的白名单
											if(!isWhite) {
												//不存在白名单抛出异常
												throw new BussinessException("10004", "领取会员三户套餐限制");

											}
										}
									 }
						    	 }
							    
						   }
						   //有品牌信息
						   if(beanMap.get("BRAND") != null && !"".equals(beanMap.get("BRAND")) && StringUtils.isNotEmpty(bean.getBrandlimit())){
							   String brand = beanMap.get("BRAND").toString();					   
					    	   String[] strLimt = bean.getBrandlimit().split("\\|\\|");
					    	   if(strLimt != null && strLimt.length>0) {
					    		  for (String string : strLimt) {
									if(brand.contains(string.replaceAll("\\*", ""))) {
										//查询是否有从黑名单提取出来的白名单
										if(!isWhite) {
											//不存在白名单抛出异常
											throw new BussinessException("10005","领取会员三户品牌限制");
										}
									}
								  }
					    	   }						    
						   } 
					   }else{//日志记录查询失败，再调三户套餐查询接口
						   //if(StringUtils.isNotEmpty(bean.getLimit()) || StringUtils.isNotEmpty(bean.getBrandlimit())){ //有套餐黑名单
							   //System.out.println("领取会员+++++++++++++++++++日志记录查询失败，再调三户套餐查询接口");
							   invokeEcb(bean.getBrandlimit(),bean.getLimit(),userid, cpid, spid,isWhite);
						   //}
					   }
				   }else{//无三户查询记录，调ECB查询三户
					   //if(StringUtils.isNotEmpty(bean.getLimit()) || StringUtils.isNotEmpty(bean.getBrandlimit())){ //有套餐黑名单
						   //System.out.println("领取会员++++++++++++++++++++无三户查询记录，调ECB查询三户");
						   invokeEcb(bean.getBrandlimit(),bean.getLimit(),userid, cpid, spid,isWhite);
					   //}
				   }
			   }		  
		}
	}

	
	/**
	 * 调ECB查询三户套餐，并判断是否黑名单
	 * @param limit 黑名单套餐列表
	 * @param userid 手机号码
	 * @param cpid
	 * @param spid
	 * @throws BussinessException
	 */
	private void invokeEcb(String brandlimit,String limit,String userid, String cpid, String spid,boolean iswhite)throws BussinessException{
		//System.out.println("++++++++++++++++++调ecb接口查三户信息");
		String result = null;

	    try {
	        result = URLUtil.get(
	        dictionaryDao.getValue("ecbUrl") + "?userid=" + userid + "&cpid=" + cpid + "&spid=" + spid, 
	        //"http://127.0.0.52:9999/ecb/queryecb.do" + "?userid=" + userid + "&cpid=" + cpid + "&spid=" + spid,
	        NumberUtils.toInt(dictionaryDao.getValue("ecbTimeout")));
	    	  //result ="{\"errorInfo\":\"\",\"resultCode\":\"0\",\"pacakge\":\"[POL064]新4G沃享流量王29档\",\"brand\":\"沃4G\"}";
	    } catch (Exception e) {
	    	throw new BussinessException("20008","调用三户套查询接口失败");
	    }
        //System.out.println("++++++++++++++查三户信息返回信息result:"+result);
	    if (result == null) {
	    	throw new BussinessException("20009","调用三户套查询接口失败null");
	    }
	    JSONObject obj = JSON.parseObject(result);
        if ((!obj.get("resultCode").toString().equals("0")) && 
          (!obj.get("resultCode").toString().equals("10003"))) {
          String errorInfo = "用户三户查询结果异常";
          throw new BussinessException(obj.get("resultCode").toString(),errorInfo);
        }
        if(StringUtils.isNotEmpty(limit) && obj.get("pacakge") != null && StringUtils.isNotEmpty(obj.get("pacakge").toString())
        		&& StringUtils.isNotEmpty(limit)) {
	    	  String[] strLimt = limit.split("\\|\\|");
	    	  if(strLimt != null && strLimt.length>0) {
	    		  for (String string : strLimt) {
					 if(obj.get("pacakge").toString().contains(string.replaceAll("\\*", ""))) {
						if(!iswhite) {
							throw new BussinessException("10004", "领取会员三户套餐限制");
						}
					 }
				 }
	    	  }
	     }
        if(StringUtils.isNotEmpty(brandlimit) && obj.get("brand") != null && StringUtils.isNotEmpty(obj.get("brand").toString())
        		&& StringUtils.isNotEmpty(brandlimit)) {
	    	  String[] strLimt = brandlimit.split("\\|\\|");
	    	  if(strLimt != null && strLimt.length>0) {
	    		  for (String string : strLimt) {
					 if(obj.get("brand").toString().contains(string.replaceAll("\\*", ""))) {
						 if(!iswhite) {
							 throw new BussinessException("10005", "领取会员三户品牌限制");
						 }
					 }
				 }
	    	  }
	     }
	}
	
	public static void main(String[] args) {
		EcbVipService service = new EcbVipService();
		try {
			//service.queryEcb("18524262964","tencent","6","","","1");
		} catch (Exception e) {
			
			e.printStackTrace();
		}
	}
	
	
	public void queryEcbYoutuExtra(String userid, String cpid, String spid, String province, int type, String activetype) throws BussinessException {
		boolean isWhite=ecbJoinWhiteDao.queryEcbJoinWhite(cpid,spid,province,activetype,userid)>0 ?true:false;
		if(isWhite){
			return;
		}

		//查询是否配置黑名单套餐限制
		ECBJoinBean	bean = ecbJoinConfigDao.queryEcbJoinConfig(cpid, spid, province, activetype);
		//20220517 将三户限制去掉 can.he  bean = null;
		bean = null;
		if(bean != null && bean.getStatus() == 0) {
			List list = eCBLogTempDao.queryEcbTemp(userid, cpid, spid);
			if(list != null && list.size()>0){//有三户查询记录
				Map beanMap = (Map)list.get(0);
				if("0".equals(beanMap.get("RESULTCODE"))){//查询成功
					//有套餐信息
					if(beanMap.get("PACAKGE") != null && !"".equals(beanMap.get("PACAKGE")) && StringUtils.isNotEmpty(bean.getLimit())){
						String pacakge = beanMap.get("PACAKGE").toString();
						String[] strLimt = bean.getLimit().split("\\|\\|");
						if(strLimt != null && strLimt.length>0) {
							for (String string : strLimt) {
								if(pacakge.contains(string.replaceAll("\\*", ""))) {
									throw new BussinessException("10004", "领取会员三户套餐限制");
								}
							}
						}
						
					}
					//有品牌信息
					if(beanMap.get("BRAND") != null && !"".equals(beanMap.get("BRAND")) && StringUtils.isNotEmpty(bean.getBrandlimit())){
						String brand = beanMap.get("BRAND").toString();					   
						String[] strLimt = bean.getBrandlimit().split("\\|\\|");
						if(strLimt != null && strLimt.length>0) {
							for (String string : strLimt) {
								if(brand.contains(string.replaceAll("\\*", ""))) {
									throw new BussinessException("10005","领取会员三户品牌限制");
								}
							}
						}						    
					} 
					invokeEcbYoutuExtra(bean.getBrandlimit(),bean.getLimit(),userid, cpid, spid,isWhite);
				}
			}else{
				invokeEcbYoutuExtra(bean.getBrandlimit(),bean.getLimit(),userid, cpid, spid,isWhite);
			}
		}		  
	}
	
	private void invokeEcbYoutuExtra(String brandlimit,String limit,String userid, String cpid, String spid,boolean iswhite)throws BussinessException{
		if(iswhite){
			return;
		}
		
		String result = null;
		
		try {
			result = URLUtil.get(
					dictionaryDao.getValue("ecbUrl") + "?userid=" + userid + "&cpid=" + cpid + "&spid=" + spid, 
					NumberUtils.toInt(dictionaryDao.getValue("ecbTimeout")));
		} catch (Exception e) {
//			throw new BussinessException("20008","调用三户套查询接口失败");
			return;
		}
		if (result == null) {
//			throw new BussinessException("20009","调用三户套查询接口失败null");
			return;
		}
		JSONObject obj = JSON.parseObject(result);
		if ((!obj.get("resultCode").toString().equals("0")) && (!obj.get("resultCode").toString().equals("10003"))) {
//			String errorInfo = "用户三户查询结果异常";
//			throw new BussinessException(obj.get("resultCode").toString(),errorInfo);
			return;
		}
		if(StringUtils.isNotEmpty(limit) && obj.get("pacakge") != null && StringUtils.isNotEmpty(obj.get("pacakge").toString())
				&& StringUtils.isNotEmpty(limit)) {
			String[] strLimt = limit.split("\\|\\|");
			if(strLimt != null && strLimt.length>0) {
				for (String string : strLimt) {
					if(obj.get("pacakge").toString().contains(string.replaceAll("\\*", ""))) {
						throw new BussinessException("10004", "领取会员三户套餐限制");
					}
				}
			}
		}
		if(StringUtils.isNotEmpty(brandlimit) && obj.get("brand") != null && StringUtils.isNotEmpty(obj.get("brand").toString())
				&& StringUtils.isNotEmpty(brandlimit)) {
			String[] strLimt = brandlimit.split("\\|\\|");
			if(strLimt != null && strLimt.length>0) {
				for (String string : strLimt) {
					if(obj.get("brand").toString().contains(string.replaceAll("\\*", ""))) {
						throw new BussinessException("10005", "领取会员三户品牌限制");
					}
				}
			}
		}
	}
}
