package com.chinacreator.video.service;

import java.util.Map;
import java.util.TreeMap;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.VipLog;
import com.chinacreator.video.mapper.SysDao;
import com.chinacreator.video.mapper.VipDao;
import com.chinacreator.video.util.MD5;
import com.chinacreator.video.util.TimeUtil;
import com.chinacreator.video.util.URLUtil;

@Service
public class Fushion12VipService {
    
//    private final static String URL = "http://124.207.205.22:8081/v1/vip/renewsign/unicomflowfree";   //TEST
    private final static String URL = "http://pvip.funshion.com/v1/vip/renewsign/unicomflowfree";   //PROD
    
    
    private final static String SECRET_KEY = "GDGfs@14356!gfsdg^";
    
    private final static String SERVICE_ID = "963";
    
	private static final Logger log = LoggerFactory.getLogger("viplog");
	
	@Autowired
	private SysDao sysDao;
	
	@Autowired
	private VipDao vipDao;

	@Autowired
	VipControlService vipControlService;

	@Autowired
	ComplementSendService complementSendService;
	
	public void giveVip(VipInfo activityInfo)throws BussinessException {
		this.vipControlService.canGiveVip(activityInfo);

		VipLog vipLog = new VipLog();
		vipLog.setResultcode("0");
		vipLog.setErrorinfo("");
		vipLog.setUserid(activityInfo.getUserid());
		vipLog.setActivityType(activityInfo.getActivetype());
		vipLog.setUsertype(activityInfo.getUsertype());
		vipLog.setType(activityInfo.getType());
		vipLog.setUserval(activityInfo.getUserval());
		
        //订单重试
        boolean flagCorp=false;
        String toCorpOrderid=null;
        if(activityInfo.getVippool()!=null && !"".equals(activityInfo.getVippool().trim())){
        	toCorpOrderid =  vipDao.getOrderId2(activityInfo.getUserid(), activityInfo.getActivetype(),activityInfo.getVippool());
        }else{
        	toCorpOrderid =  vipDao.getOrderId(activityInfo.getUserid(), activityInfo.getActivetype());
        }
        if(toCorpOrderid != null && !"".equals(toCorpOrderid)){
        	flagCorp=true;
        }

		try {
			Map<String,String> param = new TreeMap<String,String>();
			String service_id = SERVICE_ID;
			vipLog.setVipdays("31");
			
			
			//重试订单
			String cp_order = null;
			if(flagCorp){
				cp_order = toCorpOrderid;
			}else{
				cp_order = "fx" + this.sysDao.getId();
			}
			
			String begintime = this.sysDao.getSysTime();
			String endtime = this.sysDao.getLastDay();

			vipLog.setOrderid(cp_order);
			vipLog.setBegintime(begintime);
			vipLog.setEndtime(endtime);

			String cl = "web";
			String action = "sign";
			String ctime = TimeUtil.timeStamp();
			String mobile = activityInfo.getUserval();

			//签名MD5加密
			String sign = MD5.MD5Encode("action="+action+"&cl="+cl+"&cp_order="+cp_order+"&ctime="+ctime+"&mobile="+mobile+"&service_id="+service_id+"&key="+SECRET_KEY );

			//合作方直充接口参数
			param.put("cl",cl);
			param.put("ctime",ctime);
			param.put("action",action);
			param.put("mobile",mobile);
			param.put("cp_order",cp_order);
			param.put("service_id",service_id);
			param.put("sign",sign);
			
			log.debug("============签名后url============");
			String url = URLUtil.mapToUrl(URL,param);
			log.debug(url);
			
			String result = null;
			try {
				vipLog.setOutput(JSON.toJSONString(param));
//				result = "{\"retcode\":\"200\",\"retmsg\":\"OK\",\"rettime\":\"1544768336\",\"retsign\":\"c2bb2099dfa4ec4fea31b9e6b142459c\"}";
                result = URLUtil.get(url);
				log.debug(result);
				vipLog.setReturnput(result);
			} catch (Exception e) {
				vipLog.setErrorinfo("赠送会员超时或异常");
				vipLog.setResultcode("9070");
				throw new BussinessException("9070", "赠送会员超时或异常");
			}
			JSONObject obj = JSON.parseObject(result);
			
			//解析返回结果
			String code = obj.getString("retcode");
			String msg = obj.getString("retmsg");
			
			//订单是否成功
			boolean flagvip = false;
			if("200".equals(code)){
				flagvip=true;
			}
			
			try {
				//把原有的9070订单标记失败
				if(flagCorp && flagvip && vipDao.getCount9070(activityInfo.getUserid(), toCorpOrderid)>0){
					vipDao.updateOrderIdAll(activityInfo.getUserid(), toCorpOrderid, "1","订单重试表明：此订单失败");
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			vipLog.setResultcode(flagvip?"0":code);
			vipLog.setErrorinfo(msg);

			complementSendService.updateJoinAccount(activityInfo,vipLog.getResultcode(),msg,cp_order);
			this.vipControlService.saveVipGive(activityInfo, vipLog.getResultcode());
			if (!flagvip) {
				throw new BussinessException("9071", "赠送会员失败(" + msg + ")");
			}
		} catch (Exception e) {
			e.printStackTrace();
			if (e instanceof BussinessException)
				throw (BussinessException) e;
			else
				throw new BussinessException("8000", e.getMessage());
		} finally {
			log.info(JSON.toJSONString(vipLog));
			saveLog(vipLog);
		}
	}
	
	public void saveLog(VipLog vipLog) {
// 		vipLog.setResultcode("1");
		
		if(vipLog.getResultcode()==null){
			vipLog.setResultcode("");
		}
		if(vipLog.getErrorinfo()==null){
			vipLog.setErrorinfo("");
		}
		vipDao.insert(vipLog);
	}

}
