package com.chinacreator.video.service;


import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.chinacreator.video.bean.*;
import com.chinacreator.video.mapper.ComplementSendDao;
import com.chinacreator.video.service.handle.GetVipService;
import com.chinacreator.video.util.StrUtil;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.VipLog;
import com.chinacreator.video.mapper.SysDao;
import com.chinacreator.video.mapper.VipDao;
import com.chinacreator.video.util.MD5;
import com.chinacreator.video.util.URLUtil;

@Component
public class GiveVipService {

    private static final String VIPURL = "https://vip.video.qq.com/fcgi-bin/comm_cgi?name=hlwmp_access_layer&cmd=1&otype=xjson";
    private static final int CHANNEL_ID = 30049;
    private static final int OPER_TYPE = 1;
    private static final String CHANNEL_SECRET = "9a381rspstgu3wt8k2mxvb2w6uiybimfv2k4mkjxaieiyxojoi31vfpg2iovfg71";
    private static final Logger log = LoggerFactory.getLogger("viplog");

    @Autowired
    private SysDao sysDao;

    @Autowired
    private VipDao vipDao;

    @Autowired
    VipControlService vipControlService;

    @Autowired
    ComplementSendService complementSendService;

    public void give(VipInfo activityInfo) throws BussinessException {
        vipControlService.canGiveVip(activityInfo);
        VipLog vipLog = new VipLog();
        vipLog.setResultcode("0");
        vipLog.setErrorinfo("");
        vipLog.setActivityType(activityInfo.getActivetype());
        vipLog.setUserid(activityInfo.getUserid());
        vipLog.setType(activityInfo.getType());

        //查找原订单号
        boolean flagCorp = false;
        String toCorpOrderid = null;
        if (activityInfo.getVippool() != null && !"".equals(activityInfo.getVippool().trim())) {
            toCorpOrderid = vipDao.getOrderId2(activityInfo.getUserid(), activityInfo.getActivetype(), activityInfo.getVippool());
        } else {
            toCorpOrderid = vipDao.getOrderId(activityInfo.getUserid(), activityInfo.getActivetype());
        }
        if (toCorpOrderid != null && !"".equals(toCorpOrderid)) {
            flagCorp = true;
        }

        try {
            Map<String, Object> map = new HashMap<String, Object>();
            map.put("channel_id", CHANNEL_ID);

            //重试订单号
            String order_id = null;
            if (flagCorp) {
                order_id = toCorpOrderid;
            } else {
                order_id = sysDao.getId();
            }

            map.put("order_id", order_id);
            vipLog.setOrderid(order_id);
            String remark = activityInfo.getUserid();
            switch (activityInfo.getUsertype()) {
                case "1":
                    map.put("user_type", 1);//qq
                    map.put("appid", "");
                    break;
                case "2":
                    map.put("user_type", 5);//微信号
                    map.put("appid", "");
                    break;
                case "3":
                    map.put("user_type", 4);//openid
                    map.put("appid", "wx68ff4e3ba9f84df4");
                    break;
                case "4":
                    map.put("user_type", 6);//手机号
                    map.put("appid", "");
                    remark = "会员产品";
                    break;
                case "6":
                    map.put("user_type", 3);// QQ openid
                    map.put("appid", "101795054");
                    break;
                default:
                    remark = "";
                    throw new BussinessException("9072", "赠送会员失败usertype错误");
            }
            vipLog.setRemark(remark);
            vipLog.setUsertype(activityInfo.getUsertype());
            map.put("user_id", activityInfo.getUserval());
            vipLog.setUserval(activityInfo.getUserval());
            map.put("oper_type", OPER_TYPE);
            String days = sysDao.getSurplusDays();
            map.put("days", "vip_31");

            vipLog.setVipdays(days);
            String begintime = sysDao.getSysTime();
            vipLog.setBegintime(begintime);
            String endtime = sysDao.getLastDay();
            vipLog.setEndtime(endtime);
            int timestamp = (int) (System.currentTimeMillis() / 1000);
            map.put("timestamp", timestamp);
            String signature = MD5.MD5Encode(String.valueOf(CHANNEL_ID) + CHANNEL_SECRET + order_id + activityInfo.getUserval() + String.valueOf(timestamp));
            map.put("signature", signature);
            map.put("times", 1);
            map.put("remark", remark);
            map.put("callback", "");
            map.put("extend", "{\"subchannel\":\"A" + activityInfo.getActivetype() + "\"}");

            //发起请求
            String result = null;
            boolean flag9070 = false;
            JSONObject obj = null;
            try {
                vipLog.setOutput(JSON.toJSONString(map));
                result = URLUtil.post(VIPURL, JSON.toJSONString(map), 2000);
//				result = "{\"ret_code\":0,\"ret_msg\":\"\"}";
                vipLog.setReturnput(result);
                obj = JSON.parseObject(result);
            } catch (Exception e) {
                /*** 异常信息 ***/
                if (vipLog.getReturnput() == null || "".equals(vipLog.getReturnput().trim())) {
                    String errorInfotmp = e.getClass().getName() + ": " + e.getMessage().toString();
                    if (errorInfotmp.length() > 240) {
                        vipLog.setReturnput(errorInfotmp.substring(0, 240));
                    } else {
                        vipLog.setReturnput(errorInfotmp);
                    }
                }
                /*** 异常信息 ***/

                flag9070 = true;
            }


            //第一次主动重试
            if (flag9070 || result == null || obj == null || obj.get("ret_code") == null) {
                result = null;
                flag9070 = false;
                obj = null;

                /*** 保存上一条日志 ***/
                vipLog.setResultcode("9070");
                vipLog.setErrorinfo("赠送会员超时或者异常");
                log.info(JSON.toJSONString(vipLog));
                vipLog.setReturnput("");
                vipLog.setResultcode("");
                vipLog.setErrorinfo("");
                /*** 保存上一条日志 ***/

                try {
                    result = URLUtil.post(VIPURL, JSON.toJSONString(map), 2000);
                    vipLog.setReturnput(result);
                    obj = JSON.parseObject(result);
                } catch (Exception e) {
                    /*** 异常信息 ***/
                    if (vipLog.getReturnput() == null || "".equals(vipLog.getReturnput().trim())) {
                        String errorInfotmp = e.getClass().getName() + ": " + e.getMessage().toString();
                        if (errorInfotmp.length() > 240) {
                            vipLog.setReturnput(errorInfotmp.substring(0, 240));
                        } else {
                            vipLog.setReturnput(errorInfotmp);
                        }
                    }
                    /*** 异常信息 ***/

                    flag9070 = true;
                    ;
                }
            }


            //第二次主动重试
            if (flag9070 || result == null || obj == null || obj.get("ret_code") == null) {
                result = null;
                flag9070 = false;
                obj = null;

                /*** 保存上一条日志 ***/
                vipLog.setResultcode("9070");
                vipLog.setErrorinfo("赠送会员超时或者异常");
                log.info(JSON.toJSONString(vipLog));
                vipLog.setReturnput("");
                vipLog.setResultcode("");
                vipLog.setErrorinfo("");
                /*** 保存上一条日志 ***/

                try {
                    result = URLUtil.post(VIPURL, JSON.toJSONString(map), 2000);
                    vipLog.setReturnput(result);
                    obj = JSON.parseObject(result);
                } catch (Exception e) {
                    /*** 异常信息 ***/
                    if (vipLog.getReturnput() == null || "".equals(vipLog.getReturnput().trim())) {
                        String errorInfotmp = e.getClass().getName() + ": " + e.getMessage().toString();
                        if (errorInfotmp.length() > 240) {
                            vipLog.setReturnput(errorInfotmp.substring(0, 240));
                        } else {
                            vipLog.setReturnput(errorInfotmp);
                        }
                    }
                    /*** 异常信息 ***/

                    flag9070 = true;
                    ;
                }
            }

            //第三次主动重试
            if (flag9070 || result == null || obj == null || obj.get("ret_code") == null) {
                result = null;
                flag9070 = false;
                obj = null;

                /*** 保存上一条日志 ***/
                vipLog.setResultcode("9070");
                vipLog.setErrorinfo("赠送会员超时或者异常");
                log.info(JSON.toJSONString(vipLog));
                vipLog.setReturnput("");
                vipLog.setResultcode("");
                vipLog.setErrorinfo("");
                /*** 保存上一条日志 ***/

                try {
                    result = URLUtil.post(VIPURL, JSON.toJSONString(map), 2000);
                    vipLog.setReturnput(result);
                    obj = JSON.parseObject(result);
                } catch (Exception e) {
                    /*** 异常信息 ***/
                    if (vipLog.getReturnput() == null || "".equals(vipLog.getReturnput().trim())) {
                        String errorInfotmp = e.getClass().getName() + ": " + e.getMessage().toString();
                        if (errorInfotmp.length() > 240) {
                            vipLog.setReturnput(errorInfotmp.substring(0, 240));
                        } else {
                            vipLog.setReturnput(errorInfotmp);
                        }
                    }
                    /*** 异常信息 ***/

                    flag9070 = true;
                    ;
                }
            }

            //第四次主动重试
            if (flag9070 || result == null || obj == null || obj.get("ret_code") == null) {
                result = null;
                flag9070 = false;
                obj = null;

                /*** 保存上一条日志 ***/
                vipLog.setResultcode("9070");
                vipLog.setErrorinfo("赠送会员超时或者异常");
                log.info(JSON.toJSONString(vipLog));
                vipLog.setReturnput("");
                vipLog.setResultcode("");
                vipLog.setErrorinfo("");
                /*** 保存上一条日志 ***/

                try {
                    result = URLUtil.post(VIPURL, JSON.toJSONString(map), 2000);
                    vipLog.setReturnput(result);
                    obj = JSON.parseObject(result);
                } catch (Exception e) {
                    /*** 异常信息 ***/
                    if (vipLog.getReturnput() == null || "".equals(vipLog.getReturnput().trim())) {
                        String errorInfotmp = e.getClass().getName() + ": " + e.getMessage().toString();
                        if (errorInfotmp.length() > 240) {
                            vipLog.setReturnput(errorInfotmp.substring(0, 240));
                        } else {
                            vipLog.setReturnput(errorInfotmp);
                        }
                    }
                    /*** 异常信息 ***/

                    flag9070 = true;
                    ;
                }
            }

            //9070
            if (flag9070 || result == null || obj == null || obj.get("ret_code") == null) {
                vipLog.setResultcode("9070");
                vipLog.setErrorinfo("赠送会员超时或者异常");
                throw new BussinessException("9070", "赠送会员超时或者异常");
            }

            //解析返回结果
            String msg = obj.getString("ret_msg");
            int code = -100;
            if (obj.get("ret_code") != null) {
                try {
                    code = obj.getIntValue("ret_code");
                } catch (Exception e) {
                }
            }

            //订单是否成功
            boolean flagvip = false;
            if (code == 0 || code == -21001) {
                flagvip = true;
            }

            try {
                //把原有的9070订单标记失败
                if (flagCorp && flagvip && vipDao.getCount9070(activityInfo.getUserid(), toCorpOrderid) > 0) {
                    vipDao.updateOrderIdAll(activityInfo.getUserid(), toCorpOrderid, "1", "订单重试表明：此订单失败");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }

            vipLog.setResultcode(flagvip ? "0" : (code + ""));
            vipLog.setErrorinfo(msg);

            // 更新账期表的数据
            complementSendService.updateJoinAccount(activityInfo, vipLog.getResultcode(), msg, order_id);

            vipControlService.saveVipGive(activityInfo, vipLog.getResultcode());
            if (!flagvip) {
                throw new BussinessException("9071", "赠送会员失败:" + obj.getString("ret_msg"));
            }
        } catch (Exception e) {
            throw e;
        } finally {
            log.info(JSON.toJSONString(vipLog));
            saveLog(vipLog);
        }
    }

    public void saveLog(VipLog vipLog) {
//		vipLog.setResultcode("1");

        if (vipLog.getReturnput() == null) {
            vipLog.setReturnput("");
        }
        if (vipLog.getResultcode() == null) {
            vipLog.setResultcode("-0");
        }
        if (vipLog.getErrorinfo() == null) {
            vipLog.setErrorinfo("");
        }
        vipDao.insert(vipLog);
    }


    public static void main(String[] args) throws Exception {
    }

}
