package com.chinacreator.video.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.VipLog;
import com.chinacreator.video.mapper.SysDao;
import com.chinacreator.video.mapper.VipDao;
import com.chinacreator.video.util.DesUtil;
import com.chinacreator.video.util.MD5;
import com.chinacreator.video.util.TimeUtil;
import com.chinacreator.video.util.URLUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

/**
 * Create by IntelliJ IDEA.
 * Author: EricJin
 * Date: 10/24/2018 2:51 PM
 */
@Service
public class LeshiNewGiveVipService {
//    private static final String VIPURL = "http://ftest.le.com/ftl/sdk/union/vipv2";     //test
     private static final String VIPURL = "http://flow.go.le.com/ftl/sdk/union/vipv2";       //prod
    private static final Logger log = LoggerFactory.getLogger("viplog");
    @Autowired
    private SysDao sysDao;
    @Autowired
    private VipDao vipDao;
    @Autowired
    VipControlService vipControlService;

    @Autowired
    ComplementSendService complementSendService;

    public void give(VipInfo activityInfo) throws BussinessException {
        this.vipControlService.canGiveVip(activityInfo);

        VipLog vipLog = new VipLog();
        vipLog.setResultcode("0");
        vipLog.setErrorinfo("");
        vipLog.setActivityType(activityInfo.getActivetype());
        vipLog.setUserid(activityInfo.getUserid());
        vipLog.setType(activityInfo.getType());
        vipLog.setUsertype(activityInfo.getUsertype());
        vipLog.setUserval(activityInfo.getUserval());
        vipLog.setVipdays("31");

        String result ;
        try
        {
            Map<String, String> param = new HashMap<String,String>();

            String pwd = "eb0d1e4b";

            String order_id = this.sysDao.getId();
            String begintime = this.sysDao.getSysTime();
            String endtime = this.sysDao.getLastDay();

            vipLog.setOrderid(order_id);
            vipLog.setBegintime(begintime);
            vipLog.setEndtime(endtime);

            String phone = activityInfo.getUserid();
            String userid = DesUtil.encode(phone,pwd);
            String timeStamp = TimeUtil.timeStampMill();

            String signature = MD5.MD5Encode(userid + pwd + timeStamp).toLowerCase();
            userid = URLEncoder.encode(userid,"utf-8");
            param.put("phone",userid);
            param.put("timestamp",timeStamp);
            param.put("signature",signature);
            param.put("vipType",activityInfo.getType() + "");

            try
            {
                vipLog.setOutput(JSON.toJSONString(param));
                String url = URLUtil.mapToUrl(VIPURL,param);
                result = URLUtil.get(url);
//                result="{\"code\":\"0000\",\"msg\":\"会员直充成功\"}";
                vipLog.setReturnput(result);
            }
            catch (Exception e)
            {
                vipLog.setResultcode("9070");
                vipLog.setErrorinfo("赠送会员超时或异常");
                throw new BussinessException("9070", "赠送会员超时或异常");
            }
            JSONObject obj = JSON.parseObject(result);
            vipLog.setResultcode(obj.getString("code").equals("0000") ? "0" : obj.getString("code"));
            vipLog.setErrorinfo(obj.getString("msg"));

            complementSendService.updateJoinAccount(activityInfo,vipLog.getResultcode(),vipLog.getErrorinfo(),order_id);
            this.vipControlService.saveVipGive(activityInfo, vipLog.getResultcode());
            if (!vipLog.getResultcode().equals("0"))
                throw new BussinessException("9071","赠送会员失败：" + obj.getString("msg"));
        }
        catch (Exception e)
        {
            if (e instanceof BussinessException)
                throw (BussinessException) e;
            else
                throw new BussinessException("8000",e.getMessage());
        }
        finally
        {
            log.info(JSON.toJSONString(vipLog));
            saveLog(vipLog);
        }
    }

    public void saveLog(VipLog vipLog)
    {
//        vipLog.setResultcode("1");
        this.vipDao.insert(vipLog);
    }

}
