package com.chinacreator.video.service;

import com.chinacreator.video.bean.*;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.CpSpDao;
import com.chinacreator.video.mapper.QueryDao;
import com.chinacreator.video.util.MD5;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import java.util.List;

@Component
public class QueryService {
    @Autowired
    private CpSpDao spDao;

    @Autowired
    private CpSpService cpSpService;

    @Autowired
    private QueryDao queryDao;

    @Autowired
    private ComonService comonService;
    @Autowired
    private MobService mobService;
    @Autowired
    private ActivityConfigService activityService;


    public void checkQueryActity(VipInfo vipInfo) throws BussinessException {
        comonService.checkTimestamp(vipInfo.getTimestamp());
        activityService.checkActivity(vipInfo);
        checkQueryVipSign(vipInfo);
        mobService.checkVipMob(vipInfo);
        if(vipInfo.getCpid().equals("twowei")) {
            if("10011".equals(vipInfo.getSpid())){
                vipInfo.setCpid("tencent");
                vipInfo.setSpid("84");
                vipInfo.setActivetype("6");
            }else if("100611".equals(vipInfo.getSpid())){
                vipInfo.setCpid("mangtv16");
                vipInfo.setSpid("1006");
                vipInfo.setActivetype("16");
            }
        }
    }

    public void checkQueryOrder(OrderInfo orderInfo) throws BussinessException {
        comonService.checkTimestamp(orderInfo.getTimestamp());
        cpSpService.checkSp(orderInfo);
        checkqueryOrderSign(orderInfo);
        mobService.checkMob(orderInfo);
        if (orderInfo.getCpid().equals("twowei")) {
            if (orderInfo.getCanceltype() == 1) {
                orderInfo.setCpid("tencent");
                orderInfo.setSpid("6");
            } else {
                orderInfo.setCpid("tencent");
                orderInfo.setSpid("101");
            }
        }
    }

    public void checkqueryOrderSign(OrderInfo orderInfo) throws BussinessException {
        String sign = orderInfo.getSignature();
        if (StringUtils.isEmpty(sign)) {
            throw new BussinessException("9054", "signature不能为空");
        }
        CpSpBean cpSpBean = spDao.getCpSp(orderInfo.getCpid(), orderInfo.getSpid());
        String pwd = cpSpBean.getPwd();
        String localSign = MD5.MD5Encode(
                orderInfo.getUserid() + orderInfo.getCpid() + orderInfo.getSpid() +pwd + orderInfo.getTimestamp());
        if (!localSign.equals(orderInfo.getSignature())) {
            throw new BussinessException("9054", "signature校验失败");
        }
    }

    public void checkQueryVipSign(VipInfo activityInfo) throws BussinessException {
        String sign = activityInfo.getSignature();
        if (StringUtils.isEmpty(sign)) {
            throw new BussinessException("9054", "signature不能为空");
        }
        CpSpBean cpSpBean = spDao.getCpSp(activityInfo.getCpid(), activityInfo.getSpid());
        String pwd = cpSpBean.getPwd();
        String localSign = MD5
                .MD5Encode(activityInfo.getUserid() + activityInfo.getActivetype() + pwd + activityInfo.getTimestamp());
        if (!localSign.equals(activityInfo.getSignature())) {
            throw new BussinessException("9054", "signature校验失败");
        }
    }



    public List<QueryVip>  QueryVipRecord(VipInfo vipInfo) throws BussinessException {

        List<QueryVip> viplist=null;
        try {
            viplist= queryDao.queryVipJoinLog(vipInfo.getUserid(), vipInfo.getActivetype());
        }catch (Exception e){
            throw new BussinessException("9006", "会员领取记录查询失败");
        }

        return viplist;

    }

    public List<QueryOrder>  QueryOrderRecord(OrderInfo vipInfo) throws BussinessException {
        List<QueryOrder> orderList=null;

        try {
            orderList = queryDao.queryOrderRecord(vipInfo.getUserid(), vipInfo.getCpid(), vipInfo.getSpid());

        }catch (Exception e){
            throw new BussinessException("9006", "订购记录查询失败");
        }
        return orderList;

    }



}
