package com.chinacreator.video.util;

import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

public class IpAddrUtil {

	public static String getIpAddr2(HttpServletRequest request) {
		String ip = request.getHeader("X-Real-IP");
		if (inValidateIpAddr2(ip)) {
			ip = request.getHeader("X-Forwarded-For");
		}
		if (inValidateIpAddr2(ip)) {
			ip = request.getHeader("Proxy-Client-IP");
		}
		if (inValidateIpAddr2(ip)) {
			ip = request.getHeader("WL-Proxy-Client-IP");
		}
		if (inValidateIpAddr2(ip)) {
			ip = request.getHeader("clientip");
		}
		if (inValidateIpAddr2(ip)) {
			ip = request.getRemoteAddr();
		}
		if (inValidateIpAddr2(ip)) {
			ip = "null";
		} else {
			int index = ip.indexOf(",");
			if (index != -1) {
				ip = ip.substring(0, index);
			}
		}
		return ip;
	}

	private static boolean inValidateIpAddr2(String ip) {
		return (ip == null) || (ip.length() == 0) || ("unknown".equalsIgnoreCase(ip));
	}

	public static String getIpAddr(HttpServletRequest request) {
		String ip = request.getHeader("X-Real-IP");
		if (inValidateIpAddr(ip)) {
			ip = request.getHeader("X-Forwarded-For");
		}
		if (inValidateIpAddr(ip)) {
			ip = request.getHeader("Proxy-Client-IP");
		}
		if (inValidateIpAddr(ip)) {
			ip = request.getHeader("WL-Proxy-Client-IP");
		}
		if (inValidateIpAddr(ip)) {
			ip = request.getHeader("clientip");
		}
		if (inValidateIpAddr(ip)) {
			ip = request.getRemoteAddr();
		}
		if (inValidateIpAddr(ip)) {
			ip = "null";
		} else {
			int index = ip.indexOf(",");
			if (index != -1) {
				ip = ip.substring(0, index);
			}
		}
		return ip;
	}

	/**
	 * ip地址是否有效
	 * 
	 * @param ip
	 * @return true：无效，false有效
	 */
	private static boolean inValidateIpAddr(String ip) {
		return ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip) || ip.startsWith("10.") || ip.startsWith("172.") || ip.startsWith("192.");
	}

	public static String getHostIp() {
		try {
			Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces();
			while (en.hasMoreElements()) {
				NetworkInterface intf = (NetworkInterface) en.nextElement();
				Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses();
				while (enumIpAddr.hasMoreElements()) {
					InetAddress inetAddress = (InetAddress) enumIpAddr.nextElement();
					if (!inetAddress.isLoopbackAddress() && !inetAddress.isLinkLocalAddress() && inetAddress.isSiteLocalAddress()) {
						return inetAddress.getHostAddress().toString();
					}
				}
			}
		} catch (SocketException e) {
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * 获取IP
	 * @param request
	 * @return
	 */
	public static String getIp(HttpServletRequest request) {
		printHeader(request);
		return getIpAddr2(request);
	}

	/**
	 * 输出IP地址信息
	 * @param request
	 */
	private static StringBuffer printHeader(HttpServletRequest request){
		StringBuffer sb = new StringBuffer();
		sb.append("name=>remoteaddr, value=>"+request.getRemoteAddr());
		Enumeration er = request.getHeaderNames();//获取请求头的所有name值
		while(er.hasMoreElements()){
			String name	=(String) er.nextElement();
			String value = request.getHeader(name);
			sb.append("name=>"+name+", value=>"+value);
		}
		System.out.println("header信息=>"+sb);
		return sb;
	}

}

