package com.chinacreator.video.util;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * Create by IntelliJ IDEA.
 * User: EricJin
 * Date: 5/14/2018 6:18 PM
 */
public class TimeUtil {

    /**
     * 时间戳转换成日期格式字符串
     * @param seconds 精确到秒的字符串
     * @param format
     * @return
     */
    public static String timeStamp2Date(String seconds, String format) {
        if(seconds == null || seconds.isEmpty() || seconds.equals("null")){
            return "";
        }
        if(format == null || format.isEmpty()){
            format = "yyyy-MM-dd HH:mm:ss";
        }
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        return sdf.format(new Date(Long.valueOf(seconds+"000")));
    }

    /**
     * 时间戳转换成日期格式字符串
     * @param millisecond 精确到毫秒的字符串
     * @param format
     * @return
     */
    public static String timeStampMill2Date(String millisecond, String format) {
        if(millisecond == null || millisecond.isEmpty() || millisecond.equals("null")){
            return "";
        }
        if(format == null || format.isEmpty()){
            format = "yyyy-MM-dd HH:mm:ss";
        }
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        return sdf.format(new Date(Long.valueOf(millisecond)));
    }

    /**
     * 取得当前时间戳（精确到秒）
     * @return
     */
    public static String timeStamp(){
        long time = System.currentTimeMillis();
        String t = String.valueOf(time/1000);
        return t;
    }

    /**
     * 取得当前时间戳（精确到毫秒）
     * @return
     */
    public static String timeStampMill(){
        long time = System.currentTimeMillis();
        String t = String.valueOf(time);
        return t;
    }

    /**
     * 转换格式
     * @param date
     * @param format
     * @return
     */
    public static String dateFormat(Date date, String format){
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        return sdf.format(date);
    }

    public static String getDate(Calendar calendar){
        long time = calendar.getTimeInMillis();
        String t = String.valueOf(time/1000);
        return t;
    }

    /**
     * 根据日历转换格式
     * @param format
     * @param calendar
     * @return
     */
    public static String getDateFromFormat(String format, Calendar calendar) {
        Date time = calendar.getTime();
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        return sdf.format(time);
    }

    public static void main(String[] args) {
        System.out.println(timeStamp());

        Calendar calendar = Calendar.getInstance();
        calendar.set(2013,6,15);
        System.out.println(getDate(calendar));
        System.out.println(TimeUtil.timeStampMill2Date(TimeUtil.timeStampMill(),"yyyyMMddHHmmssSS"));
    }
}
