package com.chinacreator.video;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.time.DateFormatUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import com.alibaba.fastjson.JSON;
import com.chinacreator.video.bean.ActivityBean;
import com.chinacreator.video.bean.ActivityConfigBean;
import com.chinacreator.video.bean.AsynOrderBean;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.bean.VipWhiteBean;
import com.chinacreator.video.bean.WhiteBean;
import com.chinacreator.video.dto.QueryDataOutPipe;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.OrderLog;
import com.chinacreator.video.mapper.ActiveDao;
import com.chinacreator.video.mapper.ActivityConfigDao;
import com.chinacreator.video.mapper.AreaDao;
import com.chinacreator.video.mapper.AsynDao;
import com.chinacreator.video.mapper.ChannelControlDao;
import com.chinacreator.video.mapper.CpSpDao;
import com.chinacreator.video.mapper.DictionaryDao;
import com.chinacreator.video.mapper.OrderDao;
import com.chinacreator.video.mapper.OrderLogDao;
import com.chinacreator.video.mapper.QueryOrderDao;
import com.chinacreator.video.mapper.QueryPreOrderDao;
import com.chinacreator.video.mapper.SysDao;
import com.chinacreator.video.mapper.UserMsgDao;
import com.chinacreator.video.mapper.VacOrderDao;
import com.chinacreator.video.mapper.VipWhiteDao;
import com.chinacreator.video.mapper.WhiteDao;
import com.chinacreator.video.util.DesUtil;
import com.chinacreator.video.util.MD5;
import com.chinacreator.video.util.VacUtil;

@RunWith(SpringRunner.class)
@SpringBootTest
public class VideoActivityApplicationTests {

	@Autowired
	private OrderDao orderDao;
	
	@Autowired
	private CpSpDao cpSpDao;
	
	@Autowired
	private WhiteDao whiteDao;
	
	@Autowired
	private SysDao sysDao;
	
	@Autowired
	private AreaDao areaDao;
	
	@Autowired
	private ActivityConfigDao activityConfigDao;
	
	@Autowired
	private ActiveDao activeDao;
	
	@Autowired
	private QueryOrderDao queryOrderDao;
	
	@Autowired
	private UserMsgDao userMsgDao;
	
	@Autowired
	private QueryPreOrderDao queryPreOrderDao;
	
	@Autowired
	private AsynDao asynDao;
	
	@Autowired
	private OrderLogDao orderLogDao;
	
	@Autowired
	private VacOrderDao vacOrderDao;
	
	@Autowired
	private VipWhiteDao vipWhiteDao;
	
	@Autowired
	private DictionaryDao dictionaryDao;
	
	@Autowired
	private ChannelControlDao channelControlDao;
	
	@Test
	public void channelControlDao() {
		System.out.println(channelControlDao.getProvinceType("tencent", "84","") == null);
	}
	
	@Test
	public void vipwhite() {
//		VipWhiteBean bean = vipWhiteDao.getCount("0", "18574414678","tencent","84");
//		System.out.println(JSON.toJSONString(bean));
//		VipWhiteBean bean1 = vipWhiteDao.getCount("0", "18574414678","tencent","84");
//		System.out.println(JSON.toJSONString(bean1));
	}
	
	@Test
	public void time() {
		String str = dictionaryDao.getValue("continuetime");
		System.out.println(str);
		System.out.println();
		if(NumberUtils.toInt(DateFormatUtils.format(new Date(), "dd"))!=NumberUtils.toInt(str)) {
			System.out.println(11);
		}
	}
	
	@Test
	public void vacorder() {
		OrderInfo orderInfo = new OrderInfo();
		orderInfo.setUserid("18574414678");
		orderInfo.setCpid("tencent");
		orderInfo.setSpid("84");
		vacOrderDao.insertOrderInfo(orderInfo);
		System.out.println(JSON.toJSONString(vacOrderDao.getOrderInfo("18574414678", "tencent", "84")));
	}
	
	@Test
	public void md5() throws UnsupportedEncodingException {
		System.out.println(MD5.MD5Encode("TX20_dtqd1526897097326" +"0"+"tencent"+"84"+URLDecoder.decode("6YAZ48gbK31eopj%2Bd%2BWtww%3D%3D", "utf-8")+ "jfgkutbz"+"1526897097"));
	}
	
	@Test
	public void saveLog() {
		String str = "{\"apptype\":\"\",\"channel\":\"TX20_h5\",\"cpid\":\"tencent\",\"errorcode\":\"8000\",\"errorinfo\":\"系统忙,请稍后再试\",\"isexperience\":0,\"orderstatus\":2,\"ordertype\":\"2\",\"spid\":\"84\",\"status\":0,\"times\":\"28\",\"userid\":\"15116493662\"}";
		OrderLog orderLog = JSON.parseObject(str, OrderLog.class);
		orderLogDao.insertLog(orderLog);
	}
	
	@Test
	public void asynDao() {
		AsynOrderBean asynOrderBean = asynDao.queryUnNotify("unicom1809122318545279104013933");
		System.out.println(JSON.toJSONString(asynOrderBean));
	}
	
	@Test
	public void userid() {
		try {
			//System.out.println(URLEncoder.encode(DesUtil.encode("18687182964", "khrewqad"), "utf-8"));
			System.out.println(DesUtil.decode("XNPwIc7JiHbMs+wtFV1SMmVjHTEMk+LUy/Twm0T2X1g28Ey/hAWi3A==","tenc1234"));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	@Test
	public void queryPreOrderDao() {
		OrderInfo orderInfo = new OrderInfo();
		orderInfo.setUserid("18574414678");
		orderInfo.setCpid("tencent");
		orderInfo.setSpid("6");
		List<QueryDataOutPipe> list = queryPreOrderDao.getOrder(orderInfo);
		System.out.println(list.size());
	}
	
	
	@Test
	public void usermsgTest() {
		System.out.println(JSON.toJSONString(userMsgDao.getMsg("18574414678", "tencent", "84", "6")));
	}
	
	@Test
	public void activityDaoTest1() {
		ActivityBean bean = activeDao.getActivityInfo("18574414678", "tencent", "9","6");
		System.out.println(JSON.toJSON(bean));
		System.out.println(bean.getId());
		activeDao.updateVip(bean);
	}
	
	@Test
	public void activityDaoTest2() {
		ActivityBean bean = new ActivityBean();
		bean.setUserid("18574414678");
		bean.setCpid("tencent");
		bean.setSpid("6");
		//bean.setOrderchannel("");
		bean.setProvince("湖南");
		bean.setArea("张家界");
		bean.setOrdertime("20180311235959");
		bean.setEndtime("20180331235959");
		//bean.setVipendtime("20180311235959");
		bean.setActiveType("6");
		bean.setVipstatus("2");
		bean.setType("0");
		activeDao.orderActivity(bean);
	}
	
	@Test
	public void queryOrderDao() {
		OrderInfo orderInfo = new OrderInfo();
		orderInfo.setUserid("18574414678");
		orderInfo.setCpid("tencent");
		orderInfo.setSpid("6");
		queryOrderDao.getOrder(orderInfo);
	}
	
	@Test
	public void activityDaoTest3() {
		ActivityBean bean = new ActivityBean();
		bean.setUserid("18574414678");
		bean.setCpid("tencent");
		bean.setSpid("6");
		bean.setActiveType("6");
		bean.setVipstatus("2");
		bean.setEndtime("20180311235959");
		bean.setCanceltime("20180311235959");
		//bean.setCancelchannel("");
		activeDao.canceActivity(bean);
	}
	
	@Test
	public void activityConfigDaoTest() {
		ActivityConfigBean activityConfigBean = activityConfigDao.getConfig("6");
		System.out.println(JSON.toJSONString(activityConfigBean));
		ActivityConfigBean activityConfigBean2 = activityConfigDao.getConfig("6");
		System.out.println(JSON.toJSONString(activityConfigBean2));
		activityConfigDao.getConfig("5");
	}
	
	 @Test
	 public void areaTest() {
		 Map<String,String> map = areaDao.getArea("18574414678");
		 System.out.println(map.get("province"));
		 System.out.println(map.get("area"));
		 System.out.println(map.get("key"));
	 }

	@Test
	public void testGetOrder() {
		OrderInfo orderInfo = new OrderInfo();
		orderInfo.setUserid("18574414678");
		orderInfo.setCpid("tencent");
		orderInfo.setSpid("6");
		OrderInfo list = orderDao.getOrder(orderInfo);
		System.out.println(JSON.toJSONString(list));
	}
	
	@Test
	public void testGetListOrder() {
		OrderInfo orderInfo = new OrderInfo();
		orderInfo.setUserid("18574414678");
		List<OrderInfo> list =  orderDao.getOrderByUserid(orderInfo.getUserid());
		System.out.println(JSON.toJSONString(list));
	}
	
	@Test
	public void testcpsp() {
		OrderInfo orderInfo = new OrderInfo();
		orderInfo.setCpid("tencent");
		orderInfo.setSpid("6");
		System.out.println(JSON.toJSONString(cpSpDao.getCpSp(orderInfo.getCpid(),orderInfo.getSpid())));
		
		orderInfo.setCpid("tencent");
		orderInfo.setSpid("6");
		System.out.println(JSON.toJSONString(cpSpDao.getCpSp(orderInfo.getCpid(),orderInfo.getSpid())));
	}
	
	@Test
	public void whiteuser() {
		WhiteBean bean = whiteDao.getUser("18574414671","0");
		System.out.println(JSON.toJSONString(bean));
	}
	
	@Test
	public void orderDb() {
		OrderInfo orderInfo = new OrderInfo();
		orderInfo.setUserid("18574414678");
		orderInfo.setCpid("tencent");
		orderInfo.setSpid("6");
		orderInfo.setOrderchannel("");
		orderInfo.setProvince("湖南");
		orderInfo.setArea("张家界");
		orderInfo.setStatus(0);
		orderInfo.setOrdertime(sysDao.getSysTime());
		orderInfo.setEffecttime(sysDao.getEfftTime());
		orderDao.order(orderInfo);
	}
	
	@Test
	public void vacTest() throws Exception {
		System.out.println(VacUtil.vac("1", "1", "1", "2"));
	}
	
	@Test
	public void sysTest()throws Exception {
		System.out.println(sysDao.getEfftTime());
		System.out.println(sysDao.getLastDay());
		System.out.println(sysDao.getSysTime());
	}
}
